// Program TC005.cpp 
//---------------------------------------------------------------------
// A lebegpontos alulcsorduls s kikszblse                       
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.03.16.                               
//---------------------------------------------------------------------

#include <iostream.h>
#include <math.h>

void main()
{
  const double        PI = 3.141592653589793238462643;
  const double        EPSZILON = 0.00001;

  double              a, b;

  cout << "A lebegpontos alulcsorduls s kikszblse:\n";
  cout << "\n";
  a = sin(PI/4);
  b = 0.5 * sqrt(2);  //  1/2 * 2  

  // FORMZOTT KIIRATS:
  //----------------------------------------------
  // (Az ios::<formtumjelz> megadsban az ios::
  //  az ios adatfolyam objektumosztlyt jelzi)
  //----------------------------------------------
  // A kirats legyen normlalak
  cout.setf(ios::scientific);
  // A kirsi pontossg legyen 10 tizedes
  cout.precision(10);
  // Az adatok kiratsa
  cout << "a = " << a << ",  b = " << b << "\n";
  
  if (fabs(a - b) <= EPSZILON)   // fabs: lebegpontos absz.rtk fv.
    cout << "a == b (a egyenl b-vel)\n";
  else
    cout << "a != b (a nem egyenl b-vel)\n";
  cout << "\n";
}

/*
A program futtatsa:
--------------------

A lebegpontos alulcsorduls s kikszblse:

a = 7.0710678119e-01,  b = 7.0710678119e-01
a == b (a egyenl b-vel)
*/
