// Program TC007.cpp 
//---------------------------------------------------------------------
// Msodfok egyenlet megoldsa (ax+bx+c=0)                           
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.03.16.                               
//---------------------------------------------------------------------

#include <iostream.h>
#include <math.h>

void main()
{
  double a, b, c ;  // Az egyenlet egytthati
  double x1, y1  ;  // Az els gyk vals s kpzetes rsze
  double x2, y2  ;  // A msodik gyk vals s kpzetes rsze
  double diszkr  ;  // A diszkriminns


  // FORMZOTT KIIRATS:
  //----------------------------------------------
  // (Az ios::<formtumjelz> megadsban az ios::
  //  az ios adatfolyam objektumosztlyt jelzi)
  //----------------------------------------------
  // A kirats legyen fixpontos (s ne normlalak)
  cout.setf(ios::fixed);
  // A kirsi pontossg legyen 11 tizedes
  cout.precision(11);
  // Legyenek kirva a tizedes nullk az egsz szmoknl is
  cout.setf(ios::showpoint);
  // Legyen kirva a pozitv eljel is
  cout.setf(ios::showpos);

  // Adatbekrs
  cout << "Adja meg egy msodfok egyenlet egytthatit,\n";
  cout << "ha ax+bx+c=0 !\n";
  cout << "a : "; cin >> a;
  cout << "b : "; cin >> b;
  cout << "c : "; cin >> c;
  cout << "\n";

  // Az egyenlet megoldsa, az eredmnyek kiratsa 
  diszkr = b*b - 4*a*c;
  if (a == 0)
    if (b == 0)
      if (c == 0)
        cout << "Vgtelen sok megolds van: minden x 'gyk'. \n";
      else
	cout << "Nincs megolds: ellentmondsos az egyenlet. \n";
    else
     {
      x1 = -c/b;
      cout << "Egy megolds van: x = " << x1 << "\n";
     }
  else
    if (c == 0)
     {
      x1 = 0;
      x2 = -b/a;
      cout << "Kt megolds van: x1 =  " << x1 << "\n";
      cout << "                  x2 =  " << x2 << "\n";
     }
    else
      if (diszkr == 0)
       {
        x1 = -b/2/a;
        cout << "Egy megolds van: x = " << x1 << "\n";
       }
      else
       {
        x1 = -b/2/a;
        x2 = x1;
        y1 = sqrt(fabs(diszkr))/2/a;     // Sqrt(a): az a ngyzetgyke 
        y2 = -y1;                // fabs: a lebegpontos absz.rtk fv.
        if (diszkr < 0 )
         {
          cout << "Kt komplex megolds van:\n";
          cout << "    x1 = " << x1 << " + j(" << y1 << ")\n";
          cout << "    x2 = " << x2 << " + j(" << y2 << ")\n";
         }
        else
         {
          cout << "Kt vals megolds van: x1 = "<< x1 + y1 << "\n";
          cout << "                        x2 = "<< x2 + y2 << "\n";
         }
       }
  cout << "\n";
}

/*
A program futtatsa:
--------------------

Adja meg egy msodfok egyenlet egytthatit,
ha ax+bx+c=0 !
a : 11
b : 22
c : 33

Kt komplex megolds van:
    x1 = -1.00000000000 + j(+1.41421356237)
    x2 = -1.00000000000 + j(-1.41421356237)
*/
