// Program TC023.cpp                    (Numerikus mdszerek)
//-----------------------------------------------------------
// A sinus fggvny rtknek kiszmtsa kzelt mdszerrel
// A kzelt kplet:  sin(x) = x - x^3/3! + x^5/5! + - ...
// A mdszer: a kvetkez tagot mindig az elz tagbl szor-
// zssal lltjuk el mindaddig, mg az utols tag abszolt
// rtke kisebb nem lesz egy adott epszilonnl.
// ----------------------------------------------------------
// Az utols javts: 2001. 02.25.
//--------------------------------

#include <iostream.h>
#include <math.h>

void main()
{ 
  // Konstans defincik 
  const  double  epszilon = 0.0000001;
  const  double  PI = 3.141592;

  // Vltoz deklarcik
  double         fok, radian ;
  double         szinusz, szamlalo;
  double         faktor, nevezo;
  double         tag;

  cout << "Add meg a keresend fok rtkt: ";
  cin >> fok;

  // Kezdrtkek belltsa
  radian   = fok * PI/180;
  szinusz  = 0;
  tag      = radian;
  faktor   = 1;
  szamlalo = 0;
  nevezo   = 0;

  // Az approximcis ciklus
  while (fabs(tag) >= epszilon)
    { szinusz = szinusz + tag;             // sor ellltsa
      szamlalo = radian * radian;          // szmll bvtse
      nevezo = (faktor+1) * (faktor + 2);  // nevez bvitse
      tag = -tag * szamlalo/nevezo;        // j tag
      faktor = faktor + 2;

      // Kiratsi belltsok
      cout.setf(ios::fixed);       // fixpontos
      cout.precision(6);           // tizedesjegyek szma
      cout.setf(ios::showpoint);   // ha nincs rtkes tizedes, 0-t rjon
      cout << "A  sin("<<fok <<")= "<< szinusz << endl;
    } // while
} // main
