// Program TC078.cpp
//---------------------------------------------------------------------
// Rendezett tartalomjegyzk kszts
//   --> Kls program hvsa C++ programbl (system)
//   --> File trls C++ nyelven (remove)
//.....................................................................
// Hasznlata: tc078 [file csoport] [clfile]
// Funkcija:
//    A joker karaktereket is tartalmaz file csoport kijellsnek
//    megfelel file-ok attribtumait a file-nevek szerint rendezve
//    a clfile-ba msolja.
//    Ha a clfile a "con", akkor outputknt a kpernyt jelli ki.
//.....................................................................
// Lsd az ezzel megegyez mkds TC0-SORT.BAT batch programot!
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.05.13.
//---------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <iostream.h>   // cin, cout
#include <process.h>    // exit, system
#include <errno.h>      // errno
#include <string.h>     // strcpy, strcat
#include <conio.h>      // clrscr
#include <stdio.h>      // remove
//--------------------------------------------------------------

//***********************************************************************
void main( int argc, char* argv[] )
//***********************************************************************
{
 const int  MAXCOM = 30;             // A parancs maximlis hossza
 char       parancs[ MAXCOM ];       // A parancs munkavltozja

 if ( argc != 3 )
  {// A kperny trlse
   clrscr();
   // Hasznlati utasts kirsa
cerr<<" *************************************************************\n";
cerr<<" *  A rendezett tartalomjegyzk kszt program hasznlata:  *\n";
cerr<<" *            tc078.exe [file csoport] [clfile]             *\n";
cerr<<" *                                                           *\n";
cerr<<" *  Kpernyre rshoz:                                      *\n";
cerr<<" *            tc078.exe [file csoport] con                   *\n";
cerr<<" *                                                           *\n";
cerr<<" *  Plda:    tc078.exe  *.cpp  tc078.dir                    *\n";
cerr<<" *************************************************************\n";
   // Hibakd belltsa s kiugrs a DOS-ba
   exit(-1);
  }

 // A DIR parancs paramteres kiadsa az opercis rendszernek
 // (Tartalomjegyzk kszts a tempor temporlis file-ba)
 strcpy( parancs, "");               // A parancsvltoz inicializlsa
 strcat( parancs, "DIR ");           // A DIR parancs befzse
 strcat( parancs, argv[1]);          // A file csoport befzse
 strcat( parancs, " > tempor");      // A temporlis file nevnek befzse
 cout << "A kiadott parancs : " << parancs << endl;
 if ( system( parancs ) != 0 )       // A parancs kiadsa a DOS-nak
   { // Ekkor a parancsvgrehajts nem volt sikeres
     switch ( errno )                // Az errno egy rendszervltoz
       { case ENOENT :
            cout << " Hol a command.com ?" << endl;
            return;
         case ENOEXEC :
            cout << " A command.com nem vgrehajthat" << endl;
            return;
         case ENOMEM :
            cout << " Nincs elg memria" << endl;
            return;
         default :
            cout << " Hiba a system() hasznlatnl!" << endl;
            return;
       }
   }

 // A TC0-SORT.EXE parancsfile paramteres vgrehajtsa
 // (A /+n paramter adja meg a rendezsi pozcit a szvegfile-ban)
 strcpy( parancs, "TC0-SORT.EXE tempor ");
 strcat( parancs, argv[2]);
 strcat( parancs, " /+1");
 cout << "A kiadott parancs : " << parancs << endl;
 if ( system( parancs ) != 0 )       // A parancs kiadsa a DOS-nak
   { // Ekkor a parancsvgrehajts nem volt sikeres
     switch ( errno )                // Az errno egy rendszervltoz
       { case ENOENT :
            cout << " Hol a command.com ?" << endl;
            return;
         case ENOEXEC :
            cout << " A command.com nem vgrehajthat" << endl;
            return;
         case ENOMEM :
            cout << " Nincs elg memria" << endl;
            return;
         default :
            cout << " Hiba a system() hasznlatnl!" << endl;
            return;
       }
   }

 // A temporlis file trlse
 remove( "tempor" );

} //main
