// Program TC081.CPP                                         (Rajz2.cpp)
//----------------------------------------------------------------------
// Grafikai demo program
//  - koncentrikus krk rajzolsa a ltez sznsklval
//  - szvegkirs grafikus zemmdban
//----------------------------------------------------------------------
// A fejleszt krnyezet belltsai:
//   Option/Compiler/Entry/DOS-Standard: (.)
//   Option/Linker/Libraries/Graphics libraries: [x]
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.05.10.
//---------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <iostream.h>   // cin, cout
#include <graphics.h>   // grafikus fggvnyek 
#include <stdlib.h>     // exit
#include <dos.h>        // delay
#include <string.h>     // strcpy
//--------------------------------------------------------------

//------------------------------------------------------
// E modul fggvnystruktrja (prototipus modell)
//......................................................
//void main();
    void grkezd();
    void rajzol();
    void grvege();
//------------------------------------------------------

//--------------------------------
//     A fggvny defincik
//--------------------------------

void grkezd()
//----------------------------------------------------------------------
// Inicializlja a grafikus rendszert, a hardvert grafikus mdba lltja
//----------------------------------------------------------------------
{
 int      gdriver = DETECT;    // automatikus detektlsi igny
 int      gmode, errorcode;
 char     utvonal[20];

 // cout << "Krem az egavga.bgi file elrsi utjt: ";  cin >> utvonal;
 strcpy(utvonal, "C:\\TC3\\BGI");
 initgraph(&gdriver, &gmode, utvonal);
   
 errorcode = graphresult();
 if ( errorcode != grOk )      // grOk : nincs hiba
   { cout << "Grafikus hiba: "<< grapherrormsg( errorcode ) << endl;
     exit(1);                  // a hibakddal tr vissza
   }
} //grkezd

void rajzol()
//-----------------------------------------------------------------
// Koncentrikus krket rajzol a sznsklval
//------------------------------------------------------------------
{
  char    szov[] = " Koncentrikus krk ";
  int     i,x,y;

  for (i = 1; i <= 15; i++)
   { setcolor(i) ;           // rajzolszn bellts
     circle (200,200,10*i);  // kr rajzols: kzppont koordinti,sugr
     delay(300);
   }

  setcolor (WHITE);          // rajzolszn bellts: fehr = 15
  x = getx();                // lekrdezi az aktulis x rtkt
  y = gety();                // lekrdezi az aktulis y rtkt
  moveto(x+400, y+30);       // a kurzort az x,y pontba mozgatja
  settextstyle(GOTHIC_FONT,VERT_DIR,5);
                             // gotikus karakter, alulrl felfel r
                             // tszrs betmrettel (5 szr 8*8)
  outtext(szov) ;            // szveg kirs
  delay(3000);
} //rajzol


void grvege()
//------------------------------------------------------------------------
// Lezrja a grafikus rendszert
//------------------------------------------------------------------------
{
  closegraph();  
} //grvege


/**********/
void main()
/**********/
{
  grkezd();                 // grafikus inicializls
  rajzol();                 // rajzol fggvny
  grvege();                 // grafikus rendszer lezrsa
} //main
