// Program TC103.cpp                                      (feleves.cpp)
//---------------------------------------------------------------------
// Lineris, nemlineris egyenletrendszer megoldsa, mtrixinvertls
// Gulys Adrin I.ves villamosmrnk hallgat (V/25 tk.) munkja
//.....................................................................
// A kvetkez file-okat be kell msolni az ...\INCLUDE knyvtrba:
//      tc103ablak.h
//      tc103gauss.h
//      tc103inv.h
//      tc103nlin.h
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.05.12.
//---------------------------------------------------------------------

#include <conio.h>
#include <iostream.h>
#include <dos.h>
#include <ctype.h>
#include <string.h>
#include <alloc.h>
#include <math.h>
#include <float.h>
#include <iomanip.h>
#include <fstream.h>

/*sajt kszts include file-ok*/
#include "tc103gau.h"
#include "tc103inv.h"
#include "tc103nln.h"
#include "tc103win.h"


typedef char fejlectip[20];  /*a keret fejlcbe rt szveg*/
typedef char ftnev[20];      /*file tpus nv*/

void hang();
void kursorki();
void kursorbe();
int  kilepo();
void fnyit();
void clrbuf();

void hang()
{
        sound(100);
        delay(30);
        sound(50);
        delay(30);
        nosound();
}

void kursorki()
{
   _setcursortype(_NOCURSOR);
}

void kursorbe()
{
   _setcursortype(_NORMALCURSOR);
}

int kilepo()
{
        char folyt;

        keret(20,8,60,16,4,"");
        gotoxy(5,5);
        textcolor(15);
        cputs("Biztos, hogy ki akar lpni? (I/N)");
        do{
        folyt=getch();
        folyt=toupper(folyt);
        }while((folyt!='I') && (folyt!='N'));
        hang();
        if(folyt=='I') return 1;
        else return 0;
}

void fop(fstream& adatf)
{       ftnev fnev;
        char  egykar;

        gotoxy(3,2);
        cputs("Krem adja meg a betltend fjl nevt! ");
        gotoxy(3,3);
        cin>>fnev;
        hang();
        clrbuf();
        adatf.open(fnev, ios::in);
        if (adatf.fail())
        {
          gotoxy(3,5);
          cputs("A file nem ltezik!\n");

        }
        else
        {
          window(1,1,80,25);
          textbackground(1);
          clrscr();
          textcolor(15);
          while(!adatf.eof())
          {
            adatf.get(egykar);
            cout<<egykar;
          }
          adatf.close();
        }
        getch();
        hang();
}

void clrbuf()
{ while(cin.get()!='\n'); }

void main()
{
        const int xf=1;
        const int yf=1;
        const int xa=80;
        const int ya=25;

        fstream datafile;
        char matrix[]="Mtrixinvertls";
        char linearis[]="Lineris egyenletrendszer megoldsa Gauss mdszerrel";
        char nemlin[]="Nemlineris egyenletrendszer megoldsa intervallum-felezssel";
        char fnyit[]="Fjl megnyitsa";
        char exit[]="Kilps";
        char kar2;
        int  kary,eng;
        int  engmenu=0;
/* a keret rajzolasa */
        kursorki();
        keret(20,8,63,16,4,"");
        gotoxy(4,4);
        cputs("Ksztette: Gulys Adrin V/25 tankr");
        gotoxy(6,6);
        cputs("Kand Klmn Villamosmrnki Kar");
        getch();
       do{
        keret(xf,yf,xa,ya,1,"Men");
/* a scrollozo menu kiirasa*/
        textbackground(7);
        textcolor(0);
        gotoxy(32,5);
        cputs(matrix);
        textbackground(1);
        textcolor(15);
        gotoxy(14,7);
        cputs(linearis);
        gotoxy(10,9);
        cputs(nemlin);
        gotoxy(33,11);
        cputs(fnyit);
        gotoxy(37,13);
        cputs(exit);
        gotoxy(32,5);

       eng=0;
       while(eng==0)
       {
        eng=0;
        kary=wherey();
        /*Csak a le- ,flnyilakra s az ENTER-re lp ki*/
        do{
         kar2=getch();
        }while((kar2!=72)&&(kar2!=80)&&(kar2!=13));
        hang();
        textbackground(1);
        textcolor(15);
        switch (kary)
        {
          case 7: gotoxy(14,7);
                  cputs(linearis);
                  break;
          case 9: gotoxy(10,9);
                  cputs(nemlin);
                  break;
          case 5: gotoxy(32,5);
                  cputs(matrix);
                  break;
          case 11:gotoxy(33,11);
                  cputs(fnyit);
                  break;
          case 13:gotoxy(37,13);
                  cputs(exit);
                  break;
        };
        switch (kar2)
        {
        case 72   :
                  highvideo();
                  if(kary!=5)
                  {
                    kary=(kary-2);
                  }
                  else  kary=13;
                  switch(kary)
                  {
                    case 5: gotoxy(32,5);
                            textbackground(7);
                            textcolor(0);
                            cputs(matrix);
                            break;
                    case 7: gotoxy(14,7);
                            textbackground(7);
                            textcolor(0);
                            cputs(linearis);
                            break;
                    case 9: gotoxy(10,9);
                            textbackground(7);
                            textcolor(0);
                            cputs(nemlin);
                            break;
                    case 11:gotoxy(33,11);
                            textbackground(7);
                            textcolor(0);
                            cputs(fnyit);
                            break;
                    case 13:gotoxy(37,13);
                            textbackground(7);
                            textcolor(0);
                            cputs(exit);
                            break;
                  };
                  break;
        case 80  :
                  highvideo();
                  if(kary!=13)
                  {
                    kary=(kary+2);
                  }
                  else kary=5;
                  switch(kary)
                  {
                    case 5: gotoxy(32,5);
                            textbackground(7);
                            textcolor(0);
                            cputs(matrix);
                            break;
                    case 7: gotoxy(14,7);
                            textbackground(7);
                            textcolor(0);
                            cputs(linearis);
                            break;
                    case 9: gotoxy(10,9);
                            textbackground(7);
                            textcolor(0);
                            cputs(nemlin);
                            break;
                    case 11:gotoxy(33,11);
                            textbackground(7);
                            textcolor(0);
                            cputs(fnyit);
                            break;
                    case 13:gotoxy(37,13);
                            textbackground(7);
                            textcolor(0);
                            cputs(exit);
                            break;
                  };
                  break;
        case 13 : eng=1;
                  break;

        };
       }
       switch(kary)
       {
         case 5: clrscr();
                 keret(5,5,75,20,5,matrix);
                 invertal();
                 break;
         case 7: clrscr();
                 keret(5,5,75,20,5,linearis);
                 gauss();
                 break;
         case 9: clrscr();
                 keret(5,5,75,20,5,nemlin);
                 intfel();
                 break;
         case 11:clrscr();
                 keret(15,5,65,20,5,"File nyits");
                 fop(datafile);
                 break;
         case 13:engmenu=kilepo();break;
       };
      }while(engmenu==0);
 window(1,1,80,25);
 textbackground(0);
 textcolor(7);
 clrscr();
 kursorbe();
}