/* Program TX005.c */
/*---------------------------------------------------------------------*/
/* A lebegpontos alulcsorduls s kikszblse                       */
/*---------------------------------------------------------------------*/
/* Az utols javts dtuma: 2000.02.21.                               */
/*---------------------------------------------------------------------*/

#include <stdio.h>
#include <math.h>

void main(void)
{
  const double        PI = 3.141592653589793238462643;
  const double        EPSZILON = 0.00001;

  double              a, b;

  printf("A lebegpontos alulcsorduls s kikszblse:\n");
  printf("\n");
  a = sin(PI/4);
  b = 0.5 * sqrt(2);  /*  1/2 * 2  */
  printf("a = %.11E,  b = %.11E \n", a, b);
  if (fabs(a - b) <= EPSZILON)   /* fabs: lebegpontos absz.rtk fv.*/
    printf("a == b \n");
  else
    printf("a != b \n");
  printf("\n");
}

/*
A program futtatsa:
--------------------

A lebegpontos alulcsorduls s kikszblse:

a =  7.0710678119E-01,  b =  7.0710678119E-01
a == b
*/
