/* Program TX010.c */
/*---------------------------------------------------------------------*/
/* t adott szm sszegnek meghatrozsa                              */
/* (Felttelezve, hogy a fixpontos sszeg nem csordul tl.)            */
/* A ciklusutastsok demonstrcija                                   */
/*---------------------------------------------------------------------*/
/* Az utols javts dtuma: 2000.02.24.                               */
/*---------------------------------------------------------------------*/

#include <stdio.h>

void main(void)
{
  const int     MAX = 5;

  int           x, szumma ;
  int           index ;

  printf("FOR ciklus:\n");
  szumma = 0;
  for (index = 1; index <= MAX; index = index + 1) 
    {                            /* belp, ha a felttel igaz */  
     printf("A(z) %d-edik adat: ",index); scanf("%d",&x);
     szumma = szumma + x;
    }
  printf("A(z) %d szm sszege : %d\n", MAX, szumma);
  printf("\n");

  printf("WHILE ciklus:\n");
  szumma = 0;
  index = 1;
  while (index <= MAX)           /* belp, ha a felttel igaz */
    {
     printf("A(z) %d-edik adat: ",index); scanf("%d",&x);
     szumma = szumma + x;
     index = index + 1;
    }
  printf("A(z) %d szm sszege:  %d\n", MAX, szumma);
  printf("\n");

  printf("DO WHILE htultesztel ciklus:\n");
  szumma = 0;
  index = 1;
  do {
      printf("A(z) %d-edik adat: ",index); scanf("%d",&x);
      szumma = szumma + x;
      index = index + 1;
     } while (index <= MAX);     /* kilp, ha a felttel hamis */
  printf("A(z) %d szm sszege: %d\n", MAX, szumma);
  printf("\n");
}

/*
A program futtatsa:
--------------------

FOR ciklus:
A(z) 1-edik adat: 2
A(z) 2-edik adat: 4
A(z) 3-edik adat: 6
A(z) 4-edik adat: 8
A(z) 5-edik adat: 10

A 5 szm sszege:  30

WHILE ciklus:
A(z) 1-edik adat: 2
A(z) 2-edik adat: 4
A(z) 3-edik adat: 6
A(z) 4-edik adat: 8
A(z) 5-edik adat: 10

A 5 szm sszege:  30

REPEAT ciklus:
A(z) 1-edik adat: 2
A(z) 2-edik adat: 4
A(z) 3-edik adat: 6
A(z) 4-edik adat: 8
A(z) 5-edik adat: 10

A 5 szm sszege:  30
*/
