// Program TX015.c 
//----------------------------------------------------------------------
// Prmvizsglat I.                                                     
// (Prmszmoknak nevezzk azokat a pozitv egszeket, melyek           
// csak 1-gyel s nmagukkal oszthatak.)                               
//----------------------------------------------------------------------
// Az utols javts dtuma: 2000.03.05.                                
//----------------------------------------------------------------------

#include <iostream.h>
#include <math.h>

inline int  mod(int a, int b)
// Az egsz oszts maradkt adja vissza, sajt inline (sorok kzti)
// fggvny, nincs szksg a fggvnyhvs adminisztrciira, 
// hatkonyabb, csak rvid, nhny soros fggvnynl alkalmazhat,
// helyben behelyettestve lehet lefordtani.
{
  int   maradek;
  maradek = a - floor(a/b) * b;
  return maradek;
}  // a mod fggvny vge 

/**************/
void main(void)
/**************/
{
  int       oszto, p;
  char      oszthato;
  double    gyok;
  
  cout << "A vizsgland szm: "; cin >> p;

  if (p == 2)
    cout << "A 2 egy prmszm.\n";
  else
    if ((p < 2) || (mod(p, 2) == 0))
      cout << "A(z) " << p << " nem prmszm, mert 2-vel oszthat.\n";
    else
      // Ekkor p >= 3, s pratlan 
     {
      oszto = 3;
      oszthato = 'N';
      gyok = sqrt((double)p) ;
      while (oszto <= floor(gyok) && oszthato == 'N')
        //  sqrt a ngyzetgykfggvny 
        {
         if (mod(p, oszto) == 0 )
           oszthato = 'I';
         else
           oszto = oszto + 2;
         }
         if (oszthato == 'I')
           {
            cout << "A(z) " << p << " nem prmszm, ";
            cout << "els osztja: " << oszto << ".\n";
           }
         else
           cout << "A(z) " << p << " egy prmszm.\n";
     }
}

/*
A program futtatsa:
--------------------

A vizsgland szm: 1991
A(z) 1991 nem prmszm, els osztja: 11.
*/
