// Program TC013-1.cpp 
//---------------------------------------------------------------------
// Vektor elemek fordtott sorrendjnek ellltsa                    
// vektorduplzs nlkl, fggvnyhasznlattal.                        
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.03.16.
//---------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok                            
//..............................................................
#include <iostream.h>   // cin, cout                            
#include <math.h>       // floor                                
//--------------------------------------------------------------

//--------------------------------------
// Globlis azonostk                  
//......................................
const int        MAX = 9;             // A vektormret definilsa
typedef char     vektortipus[MAX];    // A vektortpus definilsa
//--------------------------------------

//------------------------------------------------------
// E modul fggvnystruktrja (prototipusok)           
//......................................................
//void main();
    void feltolt(vektortipus&);
    void kiir1(vektortipus&);
    void kiir2(vektortipus&);
    void megfordit(vektortipus&);
    void kiir3(vektortipus&);
//------------------------------------------------------

//--------------------------------
//     A fggvny defincik      
//--------------------------------

void feltolt(vektortipus& avektor)
// A vektor feltltse 
{
  int       index;

  for (index = 0; index <= (MAX-1); index++)
    {
     cout << "A vektor " << index << "-ik karaktere: ";
     cin >> avektor[index];
    }
  cout << endl;    // vagy: cout << '\n';
} // feltolt

void kiir1(vektortipus& bvektor)
// A vektor fordtott kiratsa I.
{
  int       index;

  for (index = 0; index <= (MAX-1); index++)
    cout << bvektor[(MAX-1)-index];
  cout << endl;
} // kiir1

void kiir2(vektortipus& cvektor)
// A vektor fordtott kiratsa II.
{
  int       index;

  for (index = (MAX-1); index >= 0; index--)
    cout << cvektor[index];
  cout << endl;
} // kiir2

void megfordit(vektortipus& dvektor)
// A vektor megfordtsa
{
  int       index;
  char      atmenet;

  for (index = 0;  index <= (MAX-1)/2; index++)
    {
     atmenet = dvektor[index];
     dvektor[index] = dvektor[(MAX-1)-index];
     dvektor[(MAX-1)-index] = atmenet;
    }
} // megfordit

void kiir3(vektortipus& evektor)
// A megfordtott vektor kiratsa
{
  int       index;

  for (index = 0; index <= (MAX-1); index++)
    cout << evektor[index];
  cout << endl;
}  // kiir3

/**********/
void main()
/**********/
{
  vektortipus        xvektor;

  // Vektorfeltlts
  feltolt(xvektor);

  // A vektor fordtott kiratsa I.
  kiir1(xvektor);

  // A vektor fordtott kiratsa II.
  kiir2(xvektor);

  // A vektor megfordtsa 
  megfordit(xvektor);

  // A megfordtott vektor kiratsa 
  kiir3(xvektor);
}

/*
A program futtatsa:
--------------------

A vektor 1-ik karaktere: A
A vektor 2-ik karaktere: B
A vektor 3-ik karaktere: C
A vektor 4-ik karaktere: D
A vektor 5-ik karaktere: E
A vektor 6-ik karaktere: F
A vektor 7-ik karaktere: G
A vektor 8-ik karaktere: H
A vektor 9-ik karaktere: I

IHGFEDCBA
IHGFEDCBA
IHGFEDCBA
*/
