// Program TC040.cpp
//---------------------------------------------------------------------
// Alapmveletek felsorolt (enumerated) tpussal.
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.03.16.
//---------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <iostream.h>   // cin, cout
//--------------------------------------------------------------

/**********/
void main()
/**********/
{
  const int       MAXNEV = 10; // A leghosszabb napnv + 1
  const int       NAPSZAM = 7;
  
  typedef enum    { hetfo, kedd, szerda, csutortok, pentek,
                    szombat, vasarnap
                  }   naptipus;
                   
  char            napnev[][MAXNEV] =
                    {"htf", "kedd", "szerda", "cstrtk", "pntek",
                     "szombat", "vasrnap"
                    };
                    
  naptipus        napindex;
  int             vasarlo_szam[NAPSZAM];
  long int        osszes_vasarlo;
  double          napi_atlag;

  // A vsrlk szmnak betltse
  for (napindex = hetfo; napindex <= vasarnap; napindex++)
    { cout << "A vsrlk szma " << napnev[napindex] << ": ";
      cin >> vasarlo_szam[napindex];
    }

  // A napi sszes vsrl szm s az tlag meghatrozsa
  osszes_vasarlo = 0;
  for (napindex = hetfo; napindex <= vasarnap; napindex++)
    osszes_vasarlo = osszes_vasarlo + vasarlo_szam[napindex];
  napi_atlag = (double)osszes_vasarlo / NAPSZAM;

  // Eredmnyek kiratsa
  cout << "Heti sszes vsrlk szma: " << osszes_vasarlo << "\n";
  cout << "Napi tlagos vsrl szm:  " << napi_atlag << "\n";
}
