// Program TC050.cpp
//---------------------------------------------------------------------
// Objektumhasznlat
// Osztly tpus objektum beillesztett metdussal
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.04.04.
//---------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <iostream.h>   // cin, cout
#include <string.h>     // strcpy
//--------------------------------------------------------------

//--------------------------------------
// Globlis azonostk
//......................................
class dolgozo                           // Ez egy osztly-tpus
{                                       // beillesztett metdussal
  private:
    // A privt tagok csak ebben az osztlyban lthatk
    // Alaprtelmezs - a "private" cmke elhagyhat
    typedef char     nev_tipus[20];

  public:
    // A nyilvnos tagok lthatak csak kvlrl is
    nev_tipus        neve;              // Adattag
    long int         azonositoja;       // Adattag
    long int         fizetese;          // Adattag
    
    void adatkiirasa()
    // Ez egy bels metdustag (osztlyfggvny) defincija
    {
      cout << "Nv       : " << neve        << "\n";
      cout << "Azonost : " << azonositoja << "\n";
      cout << "Fizets   : " << fizetese    << "\n";
      cout << "\n";
    }; // adatkiirasa
}; // dolgozo
//--------------------------------------


/**********/
void main()
/**********/
{
  dolgozo       munkas,               // Osztly tpus objektumok,
                fonok1, fonok2;       //     azaz osztlyvltozk

  // rtkads az objektumok vltoz tagjainak

  strcpy(munkas.neve, "Kiss Jnos");
  munkas.azonositoja = 123456L;       // Long int konstans
  munkas.fizetese = 20000L;           // Long int konstans

  strcpy(fonok1.neve, "Nagy Pter");
  fonok1.azonositoja = 12L;           // Long int konstans
  fonok1.fizetese = 200000L;          // Long int konstans

  // Objektum rtkads
  fonok2 = fonok1;

  // Kiiratas az objektumok metdusval
  munkas.adatkiirasa();
  fonok1.adatkiirasa();
  fonok2.adatkiirasa();
} //main
