// Program TC101.cpp                                        (tuske.cpp)
//---------------------------------------------------------------------
// Tske jtk
// Gal Gbor I.ves villamosmrnk hallgat (V/25 tk.) munkja
// ....................................................................
// Bellts a 175. sorban:
// Ha az eredeti fejleszt krnyezetben van a megfelel .bgi file, akkor
//	initgraph(&gd, &gm, "C:\\TC3\\BGI");
// Ha az aktulis alknyvtrban van a megfelel .bgi file, akkor
// 	initgraph(&gd, &gm, "");
// Az eredmny a TC101.DAT file-ba kerl.
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.05.12.
//---------------------------------------------------------------------

#include <fstream.h>
#include <graphics.h>
#include <conio.h>
#include <stdlib.h>
#include <dos.h>
#include <ctype.h>

#define true 1;
#define false 0;

typedef int tpar[2][2];

int tabla[9][9];                              // a tabla adatbazisa
int gd, gm;                                   // grafikai valltozo
int x0, y0, GrOszt;                           // pozicio valltozo
char ch,s;
char buf[30];
tpar par;
int ii;
int xx,a;
  char nev[20],nev1[20];
  int pont;
  char csucs[3];

void windo(void)
{
 _setcursortype(_NOCURSOR);
window(1,1,80,25);
 textbackground(CYAN);
 clrscr();
window(5,4,34,12);
 textbackground(BLACK);
 clrscr();
window(3,3,32,11);
 textbackground(YELLOW);
 textcolor(YELLOW);
 clrscr();
 gotoxy(1,1);
 cprintf("Ŀ\n\r");
 cprintf("                           \n\r");
 cprintf("                           \n\r");
 cprintf("                           \n\r");
 cprintf("                           \n\r");
 cprintf("                           \n\r");
 cprintf("                           \n\r");
 cprintf("                           \n\r");
 cprintf("");
 gotoxy(10,2);
 cprintf("F O M E N U");
 gotoxy(7,4);
 cprintf("1. Nv megadsa ");
 gotoxy(7,5);
 cprintf("2. Jtk indts");
  gotoxy(7,6);
window(44,4,73,12);
 textbackground(BLACK);
 clrscr();
window(42,3,71,11);
 textbackground(YELLOW);
 textcolor(YELLOW);
 clrscr();
 gotoxy(1,1);
 cprintf("Ŀ\n\r");
 cprintf("                           \n\r");
 cprintf("                           \n\r");
 cprintf("                           \n\r");
 cprintf("                           \n\r");
 cprintf("                           \n\r");
 cprintf("                           \n\r");
 cprintf("                           \n\r");
 cprintf("");
 gotoxy(4,3);
 cprintf("Nv : %s",nev);
 gotoxy(4,4);
 gotoxy(4,6);
 cprintf("Rekord: %s");
 gotoxy(6,8);
 cprintf("%s",buf);
 window(22,16,61,24);
 textbackground(BLACK);
 clrscr();
window(20,15,59,23);
 textbackground(BLUE);
 textcolor(YELLOW);
 clrscr();
 gotoxy(1,1);
 cprintf("Ŀ\n\r");
 cprintf("                                     \n\r");
 cprintf("                                     \n\r");
 cprintf("           ESC. Kilps              \n\r");
 cprintf("\n\r");
 cprintf("Ŀ\n\r");
 cprintf("    Ksztette: Gal Gbor   V/25    \n\r");
 cprintf("         Budapest  2000.05.09        \n\r");
 cprintf("");

}

////////////////////////////nevbekeres/////////////////////
void nevbe(void)
 {
  for(a=0;a<20;a++)nev[a]=0;
  gotoxy(3,2);cprintf("Kerem a nevet:");
  for(a=0;a<20;)
   {
     s=getch();
     if(s==13 || s==27) break;
     if((s>=65 && s<=90) || s==32 || (s>=97 && s<=122))
       {putch(s);nev[a++]=s;}       //1 karaktert kirak a kepernyore
     if (s==8 && a>0)               //8:backspace scan kodja
       {nev[a++]=s;nev[a]=' ';putch(s);putch(32);putch(s);a-=2;}
   }
 }

///////////////////////////rekord olvasasa/////////////////
void rekord(void)
{
  int az;
  fstream record;
  record.open("TC101.DAT",ios::in);
  if(record.fail())
   {
    record.open("TC101.DAT",ios::out);
    record<<"45-";
    record.close();
    record.open("TC101.DAT",ios::in);
    if(record.fail()) { cprintf("Hiba bazzeg\n"); }
   }
  record.getline(buf,30);     //buf-ba max 30 karaktert rak
  record.close();
  for(az=0;buf[az]!='-';az++)
     csucs[az]=buf[az];
}

///////////////////////////////rekord mentes/////////////////////
void recorder(void)
{
 fstream record;
 char segg[6];
 int p;
 itoa(pont,segg,10);
 p=atoi(csucs);
 if(pont<p)
   {
     record.open("TC101.dat",ios::out);
     if (record.fail()) cprintf("Hiba\n");
     record<<segg<<"-"<<nev;
     record.close();
   }
}


// **************** grafika inicializalo resz ****************

void GrInit()
{
	detectgraph(&gd, &gm);
	if (gd == 1) gm = 0;
	// Ha az eredeti fejleszt krnyezetben van a megfelel .bgi file
	initgraph(&gd, &gm, "C:\\TC3\\BGI");
	// Ha az aktulis alknyvtrban van a megfelel .bgi file
	// initgraph(&gd, &gm, "");
	if (getmaxx() / 20 > getmaxy() / 20) GrOszt = getmaxy() / 20;
        else GrOszt = getmaxx() / 20;
        setbkcolor(7);
        if (gd == 1) settextstyle(1, 0, 3);
        else settextstyle(1, 0, 5);
}

// ********************** jatektabla inicializalo *****************

void Tablainit()
{
        int i, j;

        // **** a tabla elemeinek biztonsagi nullazasa ****
        for (i = 0; i <= 8; i++)
         {
                for (j = 0; j <= 8; j++) tabla[i][j] = 255;
         }
        // *** a babuk elhelyezese a tablan ***
        for (i = 3; i <= 5; i++)
         {
                for (j = 0; j <= 8; j++)
                 {
                        tabla[i][j] = 1;
                        tabla[j][i] = 1;
                 }
         }
        // *** a kozepso babu kitorlese ***
        tabla[4][4] = 0;
}

// **** szin beallitas ***

void Color(char i, char j)
{
        // *** rajzolo- es a hatter- szin beallitasa ***
        setcolor(j);
        setfillstyle(i, j);
}

// ******************** a tabla alapszinenek beallitasa *************

void Alap()
{
        switch (gd)
         {
                // *** CGA kepernyo ***
                case 1:
                 {
                        Color(1, 1);
                        break;
                 }
                // *** EGA es VGA kepernyo ***
                case 3:
                case 9:
                 {
                        Color(1, 2);
                        break;
                 }
                // *** HERCULES kepernyo ***
                case 7:
                 {
                        Color(9, 15);
                        break;
                 }
                default: break;
         }
}

// *********************** a babu alapszinenek beallitasa ********

void Pszin(char i)
{
        switch (gd)
         {
         // *** CGA eseten ***
                case 1:
                 {
                        if (i == 3) Color(1, 2);
                        else Color(1, 3);
                        break;
                 }
                // *** EGA es VGA eseten ***
                case 3:
                case 9:
                 {
                        if (i == 3) Color(1,12);
                        else Color(1, 14);
                        break;
                 }
                // *** HERCULES eseten ***
                case 7:
                 {
                        Color(1, 15);
                        break;
                 }
                default: break;
         }
        // *** Az ures mezon a babu mindenkepp hatterszinu ***
        if ( i == 0) Color(1, 0);
}

// ************** a vonalak szinenek beallitasa ****************

void Vszin(char i)
{
        switch (gd)
         {
                case 1:
                 {
                        switch (i)
                         {
                                // *** CGA alaphelyzetben levo babu ***
                                case 1:
                                 {
                                        Color(1, 2);
                                        break;
                                 }
                                // *** CGA ugrasra kijelolt babu ***
                                case 2:
                                 {
                                        Color(1, 2);
                                        break;
                                 }
                                // *** CGA atugrott babu ***
                                case 3:
                                 {
                                        Color(1, 3);
                                        break;
                                 }
                                default: break;
                         }
                        break;
                 }
                // *** EGA es VGA eseten ***
                case 3:
                case 9:
                 {
                        Color(1, 1);
                        break;
                 }
                // *** HERCULES ***
                case 7:
                 {
                        Color(1, 0);
                        break;
                 }
                default: break;
         }
}

// ********************** a babu letorlese ************************

void Torol(int x,int y,int r)
{
        Alap();
        bar(x - r, y - r - 3, x + r + 3, y + r);
}

// ***************** a babu kirajzolasa **************************

void Pofa(unsigned char i,int x,int y)
{
        int r, j;                                       // seged valltozok

        r = GrOszt * 4 / 5;                              // babu meret meghatarozas
        if (i == 255) return;
        Torol(x, y, r);
        Pszin(i);
        if ((i & 1) == 1)
         {
                for (j = 1; j <= 2; j++)
                 {
                        x++;
                        y--;
                        circle(x, y, (int)r);
                 }
         }
        pieslice(x, y, 0, 360, r);                      //Babu lapjanak kiszinezese
        Vszin(i);
        circle(x, y, (int)r);
        if (i <= 0 )  return;                           //Arc kirajzolasa
        circle(x - r / 2, y - r / 4, (GrOszt / 5));
        circle(x + r / 2, y - r / 4, (GrOszt / 5));
        // *** a babu arckifejezesenek elkeszitese ***
        switch (i)
         {
                case 1:
                 {
                        moveto(x - r / 2, y + r / 3);
                        lineto(x + r / 2, y + r / 3);
                        break;
                 }
                case 2:
                 {
                        arc(x, y - r / 10, 225, 315, (int)(r * 2 / 3));
                        break;
                 }
                case 3:
                 {
                        arc(x, y + r * 3 / 4, 45, 135, (int)(r * 2 / 3));
                        break;
                 }
                default: break;
         }
}

void Kirajzol()
{
        int i, j;
        // *** a tabla felrajzolasara szukseges kepernyoterulet bal felso sarka ***
        x0 = getmaxx() / 2 - GrOszt * 8;
        y0 = getmaxy() / 2 - GrOszt * 8;
        Vszin(1);
        for (i = 1; i <= 4; i++)              //A tabla felrajzolasa, kiszinezese
         {
                fillellipse(getmaxx()/2-i,getmaxy()/2+i,GrOszt*10-1,GrOszt*10-1);
         }
        Alap();
        fillellipse(getmaxx()/2,getmaxy()/2,GrOszt*10-3,GrOszt*10-3);
        for (i = 0; i <= 8; i++)
         {
                for (j = 0; j <= 8; j++)
                {
                 // *** fuggolegesen elhelyezkedo babuk kirajzolasa ***
                 if ( i > 2 && i < 6)
                        {
                         Pofa(tabla[i][j], x0 + i * GrOszt * 2, y0 + j * GrOszt * 2);
                        }
                 // *** vizszintesen elhelyezkedo babuk kirajzolasa ***
                 if ( j > 2 && j < 6)
                        {
                         Pofa(tabla[i][j], x0 + i * GrOszt * 2, y0 + j * GrOszt * 2);
                        }
                }
         }
}

// ********************** a nyil iranyanak lekerdezese ***************

char irany()
{
        // *** A klaviatura leolvasasa ***
        char ir = 15;                             // alapertek beallitasa
        do
         {
                do {} while (!kbhit());
                ch = getch();
                        switch (ch)
                         {
                                case 'P':                        // fel
                                 {
                                        ir = 1;
                                        break;
                                 }
                                case 'H':                        // le
                                 {
                                        ir = 2;
                                        break;
                                 }
                                case 'M':                        // jobbra
                                 {
                                        ir = 3;
                                        break;
                                 }
                                case 'K':                        // balra
                                 {
                                        ir = 4;
                                        break;
                                 }
                                case 27:                         // ESC billentyu leutese
                                 {
                                        closegraph();
                                        ir=99;
                                        return ir;
                                 }
                                case 13:                         // ENTER billentyu leutese
                                 {
                                        ir = 0;
                                        break;
                                 }
                                default: break;
                         }
         } while (ir >= 32 || ((1L << ir) & 0x1f) == 0);
        return ir;
}

// ********************** nyil kirajzolasa a kepernyore ****************

void NyilKi(int x,int y)
{
        Vszin(1);
        moveto(x0+(x-1)*GrOszt*2,y0+(y-1)*GrOszt*2+GrOszt*4/5);
        linerel(-(GrOszt / 6), GrOszt / 3);
        linerel(GrOszt / 3, 0L);
        linerel(-(GrOszt / 6), -(GrOszt / 3));
}

// ************************* nyil letorlese a kepernyorol *************

void NyilLe(int x,int y)
{
        int x1, y1;
        Alap();
        x1 = x0 + (x - 1) * GrOszt * 2 - GrOszt / 6;
        y1 = y0 + (y - 1) * GrOszt * 2 + GrOszt * 4 / 5;
        bar(x1, y1, x1 + GrOszt / 3, y1 + GrOszt / 3);
}

// ********************** ugrasok vegpontjainak kijelolese *********

 void kijelol(tpar,int& ex)
{
        int elso, masodik;
        char i = 5, j = 5;
        char k;
        int dx, dy;
        // *** az ugro babu kijelolese ***
        do
         {
                elso = false;
                masodik = false;
                do
                 {
                        NyilKi(i, j);
                        k = irany();                                  // az irany lekerdzese
                        if (k==99)  { pont=45;ex=1;closegraph(); return; }
                         else ex=0;
                        NyilLe(i, j);
                        // *** irany vegrehajtas ***
                        switch (k)
                         {
                                case 0:                                     // Kivalasztas nyugtazasa
                                 {
                                        elso = true;
                                        break;
                                 }
                                // *** felfele ***
                                case 1:
                                 {
                                        if (j < 9)
                                         {
                                                if (tabla[i-1][j] < 255) j++;
                                         }
                                        break;
                                 }
                                // *** lefele ***
                                case 2:
                                 {
                                        if (j > 1)
                                         {
                                                if (tabla[i-1][j-2] < 255) j--;
                                         }
                                        break;
                                 }
                                // *** jobbra ***
                                case 3:
                                 {
                                        if (i < 9)
                                         {
                                                if (tabla[i][j-1] < 255) i++;
                                         }
                                        break;
                                 }
                                // *** balra ***
                                case 4:
                                 {
                                        if (i > 1)
                                         {
                                                if (tabla[i-2][j-1] < 255) i--;
                                         }
                                        break;
                                 }
                                default: break;
                         }
                        // *** a babu kijelolese ***
                        if (elso)
                         {
                                if (tabla[i-1][j-1] == 1) tabla[i-1][j-1] = 2;
                                else elso = false;
                         }
                 } while (!elso);                                    //Kezdopont megvan
                Pofa(tabla[i-1][j-1],x0+(i-1)*GrOszt*2,y0+(j-1)*GrOszt*2);
                par[0][0] = i;
                par[0][1] = j;                                       //Kezdopont tarolasa
                // *** az ugro babu celpontjanak kijelolese ***
                do
                 {
                        NyilKi(i, j);
                        k = irany();                                       // az irany lekerdezese
                        NyilLe(i, j);
                        // *** irany vegrehajtas ***
                        switch (k)
                         {
                                case 0:                                   //masodik vegpont nyugtazas
                                 {
                                        if (par[0][0] == i && par[0][1] == j)
                                         {
                                                elso = false;                         //elso vegpont torlese
                                                tabla[i-1][j-1] = 1;
                                                Pofa(tabla[i-1][j-1],x0+(i-1)*GrOszt*2,y0+(j-1)*GrOszt*2);
                                         }
                                        else masodik = (tabla[i-1][j-1] == 0);
                                        break;
                                 }
                                // *** felfele ***
                                case 1:
                                 {
                                        if (j < 9)
                                         {
                                                if (tabla[i-1][j] < 255) j++;
                                         }
                                        break;
                                 }
                                // *** lefele ***
                                case 2:
                                 {
                                        if (j > 1)
                                         {
                                                if (tabla[i-1][j-2] < 255) j--;
                                         }
                                        break;
                                 }
                                // *** jobbra ***
                                case 3:
                                 {
                                        if (i < 9)
                                         {
                                                if (tabla[i][j-1] < 255) i++;
                                         }
                                        break;
                                 }
                                // *** balra ***
                                case 4:
                                 {
                                        if (i > 1)
                                         {
                                                if (tabla[i-2][j-1] < 255) i--;
                                         }
                                        break;
                                 }
                                default: break;
                         }
                        dx = par[0][0] - i;             //Kijeloles ervenyessegenek ellenorzese
                        dy = par[0][1] - j;
                        masodik = (masodik && tabla[i + dx / 2 - 1][j + dy / 2 - 1] == 1);
                        if (masodik)
                         {
                                masodik = (labs(dx) == 0 && labs(dy) == 2 ||
                                labs(dy) == 0 && labs(dx) == 2);
                         }
                 } while (!masodik && elso);
         } while (!masodik);
        par[1][0] = i;
        par[1][1] = j;                                          //Vegpont tarolasa
}

// *************** babuk athelyezese eggyik pontrol a masikra ********

void Mozgat(tpar par)
{
        int dx, dy;
        char i, j, k;
	// *** a kiutott babu koordinatainak kiszamitasa ***
        dx = par[0][0] - par[1][0];
        dy = par[0][1] - par[1][1];
        i = par[1][0] + dx / 2;
        j = par[1][1] + dy / 2;
        if (tabla[i-1][j-1] != 1)  return;                    //A babuk atrajzolasa
        // *** a letorolt babu helye ***
        tabla[i-1][j-1] = 3;
        // *** a leutott babu leutesi folyamata ***
        Pofa(tabla[i-1][j-1],x0+(i-1)*GrOszt*2,y0+(j-1)*GrOszt*2);
        tabla[par[0][0] - 1][par[0][1] - 1] = 0;
        tabla[par[1][0] - 1][par[1][1] - 1] = 2;
 // *** a ket pozicio babujanak az atrajzolasa ***
        for (k = 0; k <= 1; k++)
         {
                i = par[k][0];
                j = par[k][1];
                Pofa(tabla[i-1][j-1],x0+(i-1)*GrOszt*2,y0+(j-1)*GrOszt*2);
         }
        delay(100);
	tabla[par[1][0] - 1][par[1][1] - 1] = 1;
        i = par[1][0] + dx / 2;
        j = par[1][1] + dy / 2;
        tabla[i-1][j-1] = 0;
        Pofa(tabla[i-1][j-1],x0+(i-1)*GrOszt*2,y0+(j-1)*GrOszt*2);
        // *** a ket pozicio babujanak atrajzolasa ***
        for (k = 0; k <= 1; k++)
         {
                i = par[k][0];
                j = par[k][1];
                Pofa(tabla[i-1][j-1],x0+(i-1)*GrOszt*2,y0+(j-1)*GrOszt*2);
         }
}

// ****** atugorhato babuk letezesenek ellenorzese *******************

int Vege(int nr)
{
        int Result;
        int i,j;
	nr = 0;
        Result = true;
        // *** fuggoleges szomszedok ellenorzese ***
        for (i = 0; i <= 8; i++)
         {
                for (j = 2; j <= 8; j++)
                 {
                        if (tabla[i][j-1] == 1 && tabla[i][j]+tabla[i][j-2] == 1) Result = false;
                 }
         }
        // *** vizszintes szomszedok ellenorzese ***
        for (i = 2; i <= 8; i++)
         {
                for (j = 0; j <= 8; j++)
                 {
                        if (tabla[i-1][j] == 1 && tabla[i-2][j]+tabla[i][j] == 1) Result = false;
                 }
         }
        // *** a tablan levo babuk megszamlalas ***
        for (i = 0; i <= 8; i++)
	 {
                for (j = 0; j <= 8; j++)
                 {
                        if (tabla[i][j] == 1) nr++;
                 }
         }
        pont=nr;
        return Result;
}

// ********************** a befejezo kepernyo felrajzolasa *********

int befejezes()
{
        char ch;
        int i;
        // *** uzenet ***
        settextjustify(1, 2);
        outtextxy(getmaxx() / 2, getmaxy() / 2, "V\202ge");
        do
	 {
                ch = getch();
         }
        while (ch != 13 && ch != 27);
        cleardevice();
        Alap();                                    //Nagymeretu babu rajza
        bar(0L, 0L, getmaxx(), getmaxy());
        if(getmaxx() / 2 > getmaxy() / 2) GrOszt = getmaxy() / 2;
        else GrOszt = getmaxx() / 2;
        // *** a jatek eredmenyenek ellemzese ***
        if (pont > 10) i = 3;
        else
         {
                if (pont == 1) i = 2;
                else i = 1;
         }
        Pofa(i, getmaxx() / 2, getmaxy() / 2);
        // *** eredmeny kiirasa a kepernyore ***
        switch (i)
         {
		case 1:
                 {
                        settextjustify(1, 0);
                        outtextxy(getmaxx() / 2, getmaxy() / 2, "el\202g j\242!!");
                        settextjustify(1, 2);
                        break;
                 }
                case 2:
                 {
                        settextjustify(1, 0);
                        outtextxy(getmaxx() / 2, getmaxy() / 2, "gartul\240lok!!");
                        settextjustify(1, 2);
                        outtextxy(getmaxx() / 2, getmaxy() / 2, "egy b\240bu maradt");
                        break;
                 }
                case 3:
                 {
                        settextjustify(1, 0);
                        outtextxy(getmaxx() / 2, getmaxy() / 2, "nem t\243l j\242!");
                        settextjustify(1, 2);
			break;
                 }
                default: break;
         }
        // *** az uj jatek megkerdezese ***
        settextjustify(1, 0);
        outtextxy(getmaxx() / 2, getmaxy() - 2, "j\240tszol m\202g? i/n");
        do
         {
                ch = getch();
         }
        while (toupper(ch) != 'I' && toupper(ch) != 'N' && ch != 27);
        if (getmaxx() / 20 > getmaxy() / 20) GrOszt = getmaxy() / 20;
        else  GrOszt = getmaxx() / 20;
        return (toupper(ch) == 'N' || ch == 27);
}

// ******************************************************************
// *                     a foprogram kezdete                        *
// ******************************************************************

void main()
{
 int menu,ex=0;
 rekord();
 while(1)
  {
    menu=0;
    clrscr;
    windo();
    while(menu!='1' && menu!='2' && menu!=27)menu=getch();
       switch(menu)
        {
         case'1':nevbe();menu=0;break;
         case'2':GrInit();
		do
		{
		cleardevice();
		Tablainit();
		Kirajzol();
		do
                 {
                        kijelol(par,ex);
                        Mozgat(par);
                        if (ex==1) break;
                 } while (!Vege(ii));
                if (ex==1) break;
         } while (!befejezes());
        recorder();
        rekord();
        closegraph();
        break;
        case 27:exit(0);
        }
  }
}

// 27 az ESC   scan kodja
// 13 az ENTER scan kodja
// par,i,j seged valtozok
