/* Program TX012.c */
/*---------------------------------------------------------------------*/
/* Vektor elemek fordtott sorrendjnek ellltsa                    */
/* vektorduplzs nlkl.                                              */
/*---------------------------------------------------------------------*/
/* Az utols javts dtuma: 2000.02.25.                               */
/*---------------------------------------------------------------------*/

/*--------------------------------------------------------------*/
/* A hivatkozott deklarcis file-ok                            */
/*..............................................................*/
#include <stdio.h>    /* printf, scanf                          */
#include <conio.h>    /* getch, putch, getche                   */
#include <math.h>     /* floor                                  */
/*--------------------------------------------------------------*/

void main()  /* A fprogram */
{
  const int    MAX = 9;

  char         a[MAX];
  int          index;
  char         atmenet;

  /* Vektorfeltlts */
  for(index = 0; index <= (MAX-1); index = index+1)
    {
     printf("A vektor %d-ik karaktere:",index);
     /*************************************************/
     /* Itt csak stringknt ("1s") szabad beolvasni,  */
     /* klnben a billentypufferben marad az Enter: */
     /*-----------------------------------------------*/
     scanf("%1s", &a[index]);
     /******************************************************/
     /* Alternatv karakter beolvass                      */
     /* a kpernyn val megjelentssel:                  */
     /*----------------------------------------------------*/
     /* a[index] = getch(); putch(a[index]); printf("\n"); */
     /*----------------------------------------------------*/
     /* vagy msknt:                                      */
     /*----------------------------------------------------*/
     /* a[index] = getche(); printf("\n");                 */
    }
  printf("\n");

  /* A vektor fordtott kiratsa I. */
  for (index = 0; index <= (MAX-1); index = index+1)
    printf("%1c", a[(MAX-1)-index]);
    /* Alternatv karakter kiirats: */
    /* putch(a[(MAX-1)-index]);      */
  printf("\n");

  /* A vektor fordtott kiratsa II. */
  for (index = (MAX-1); index >= 0;  index = index-1)
    printf("%1c", a[index]);
    /* Alternatv karakter kiirats: */
    /* putch(a[index]);              */
  printf("\n");

  /* A vektor megfordtsa */
  for (index = 0; index <= floor((MAX-1)/2); index = index+1)
    {
     atmenet = a[index];
     a[index] = a[(MAX-1)-index];
     a[(MAX-1)-index] = atmenet;
    }

  /* A megfordtott vektor kiratsa */
  for (index = 0; index <= (MAX-1); index = index + 1)
    printf("%1c", a[index]);
    /* Alternatv karakter kiirats: */
    /* putch(a[index]);              */
  printf("\n");
}

/*
A program futtatsa:
--------------------

A vektor 1-ik karaktere: A
A vektor 2-ik karaktere: B
A vektor 3-ik karaktere: C
A vektor 4-ik karaktere: D
A vektor 5-ik karaktere: E
A vektor 6-ik karaktere: F
A vektor 7-ik karaktere: G
A vektor 8-ik karaktere: H
A vektor 9-ik karaktere: I

IHGFEDCBA
IHGFEDCBA
IHGFEDCBA
*/
