// Program TC017.cpp
//----------------------------------------------------------------------
// Ikerprmszmok keresse adott N egsz szmig
//----------------------------------------------------------------------
// Az utols javts dtuma: 2000.03.16.
//----------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <iostream.h>   // cin, cout
#include <iomanip.h>    // setw
#include <math.h>       // floor, sqrt
//--------------------------------------------------------------

//------------------------------------------------------
// E modul fggvnystruktrja (prototipusok)
//......................................................
//void main();
    void hatarbekerese(int&);
    void ikerprimkereses(int);
      char primteszt(int);
//------------------------------------------------------

//--------------------------------
//     A fggvny defincik
//--------------------------------

void hatarbekerese(int& hatar)
{
  cout << "A hatrszm: "; cin >> hatar;
}  // hatarbekerese eljrs vge

char primteszt(int p)
//---------------------------------------------------------------
// Ha a p egy prm, akkor primteszt='I', egybknt primteszt='N'
//---------------------------------------------------------------
{
  int    oszto;
  char   oszthato;

  if (p == 2)
    return 'I';
  else
    {
     if (p < 2  ||  p % 2 == 0)
       return 'N' ;
     else
      // Ekkor p >= 3, s pratlan
       {
	oszto = 3;
	oszthato = 'N';
	while (oszto <= sqrt(p)  &&  oszthato == 'N')
	  {
	   if (p % oszto == 0)
	     oszthato = 'I';
	   else
	     oszto = oszto + 2;
          }
        if (oszthato == 'I')
          return 'N';
        else
          return 'I';
       }
    }
}  // a primteszt fggvny vge

void ikerprimkereses(int n)
//--------------------------------------------------------------
// Ikerprmek keresse n-ig, s kiiratsuk a kpernyre
//--------------------------------------------------------------
{                       // Az ikerprimkereses utastsblokkja
  int    vizsgaltszam;
  int    elozoprim;

  if (n < 5)
    cout << "A(z) " << n << " szmig nincsenek ikerprmek.\n";
  else
    {
     vizsgaltszam = 5;
     elozoprim    = 3;
     while (vizsgaltszam <= n)
       {
	if (primteszt(vizsgaltszam) == 'I' )
	  {
	   if (vizsgaltszam - elozoprim == 2)
	     {
	      // FORMZOTT (TBLZATOS) KIIRATS:
	      //----------------------------------------------
	      // (Az ios::<formtumjelz> megadsban az ios::
	      //  az ios adatfolyam objektumosztlyt jelzi)
	      //----------------------------------------------
	      // A kirats legyen jobbratmrtett
	      cout.setf(ios::right);
              // A tblzatsorok kiratsa
              cout << "Ikerprmek : ";
	      // A mezszlessg legyen 6 kar.
              cout << setw(6) << elozoprim ;
              cout << setw(6) << vizsgaltszam << "\n";
	     }
           elozoprim = vizsgaltszam;
          }
        vizsgaltszam = vizsgaltszam + 2;
       }
    }
}  // az ikerprimkereses fggvny vge

/**********/
void main()
/**********/
{
  int    n;

  // Adatbekrs
  hatarbekerese(n);

  // Vizsglat s a vizsglati eredmny kiiratsa
  ikerprimkereses(n);
}

/*
A program futtatsa:
--------------------

A hatrszm: 30
Ikerprmek :      3      5
Ikerprmek :      5      7
Ikerprmek :     11     13
Ikerprmek :     17     19
*/
