// Program TC042.cpp
//---------------------------------------------------------------------
// Alapmveletek struktra tpussal I.
// Adatfolyam-kezels klnbz tpus adatok esetn
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.03.18.
//---------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <iostream.h>   // cin, cout
//--------------------------------------------------------------

//--------------------------------------
// Globlis azonostk                  
//......................................
const int       MAXNEV = 20; // A leghosszabb nv hossza + 1
const int       LETSZAM = 3;

typedef struct        hallgato_tipus
          { long int    azonositoja;
            char        neve[MAXNEV];
            char        lakhelye[MAXNEV];
            float       atlaga;
          }; // hallgato_tipus
typedef hallgato_tipus        tankor_tipus[LETSZAM];
//--------------------------------------

//------------------------------------------------------
// E modul fggvnystruktrja (prototipus modell)
//......................................................
//void main();
    void adatbe(hallgato_tipus&);
      void clrbuf();
    void kiir(hallgato_tipus&);
//------------------------------------------------------

//--------------------------------
//     A fggvny defincik
//--------------------------------

void clrbuf()
{ while (cin.get() != '\n'); }

void adatbe(hallgato_tipus&  hal)
{
  cout << "azonostja : ";
        cin >> hal.azonositoja;                          clrbuf();
  cout << "  neve      : ";
        // A vezet szkzk, tabultor s sorvgjelek levgsa
        // a ws io-manipultorrral (ezt beolvass kell kvesse)
        cin >> ws;
        cin.getline(hal.neve, sizeof(hal.neve));
        if (cin.gcount() >= sizeof(hal.neve)-1)          clrbuf();
  cout << "  lakhelye  : ";
        cin >> ws;
        cin.getline(hal.lakhelye, sizeof(hal.lakhelye));
        if (cin.gcount() >= sizeof(hal.lakhelye)-1)      clrbuf();
  cout << "  tlaga    : ";
        cin >> hal.atlaga;                               clrbuf();
}

void kiir(hallgato_tipus&  diak)
{
  cout << "  azonostja : " << diak.azonositoja << "\n"; 
  cout << "  neve        : " << diak.neve        << "\n";
  cout << "  lakhelye    : " << diak.lakhelye    << "\n";
  cout << "  tlaga      : " << diak.atlaga      << "\n";
}

/**********/
void main()
/**********/
{
  tankor_tipus     tankor;
  int              sorszam;

  // Adatbekrs
  for (sorszam = 0; sorszam < LETSZAM; sorszam++)
    { cout << "A(z) " << (sorszam+1) << "-ik hallgat: \n";
      adatbe(tankor[sorszam]);
    }

  // Kirs
  for (sorszam = 0; sorszam < LETSZAM; sorszam++)
    { cout << "A(z) " << (sorszam+1) << "-ik hallgat: \n";
      kiir(tankor[sorszam]);
    }
} //main
