// Program TC052.cpp
//---------------------------------------------------------------------
// Objektumhasznlat
// Struktra tpus objektum kls metdussal
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.04.04.
//---------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <iostream.h>   // cin, cout
#include <string.h>     // strcpy
//--------------------------------------------------------------

//--------------------------------------
// Globlis azonostk
//......................................
struct dolgozo                           // Ez egy struktra-tpus
{                                        // kls metdussal
  private:
    // A privt tagok csak ebben a struktrban lthatk
    typedef char     nev_tipus[20];

  public:
    // A nyilvnos tagok lthatak csak kvlrl is
    // Alaprtelmezs - a "public" cmke elhagyhat
    nev_tipus        neve;              // Adattag
    long int         azonositoja;       // Adattag
    long int         fizetese;          // Adattag

    void adatkiirasa();                 // Metdustag prototpusa
                                        // (a definci kvl van)
}; // dolgozo
//--------------------------------------

void dolgozo::adatkiirasa()
// Ez egy kls metdus a "::" hivatkozssal az osztly nevre
// (A "::" szimblum a hatskr kijellsre szolgl)
{                             
  cout << "Nv       : " << neve        << "\n";
  cout << "Azonost : " << azonositoja << "\n";
  cout << "Fizets   : " << fizetese    << "\n";
  cout << "\n";
}; // adatkiirasa


/**********/
void main()
/**********/
{
  dolgozo       munkas,               // Struktra tpus objektumok,
                fonok1, fonok2;       //     azaz struktra-vltozk

  // rtkads az objektumok vltoz tagjainak

  strcpy(munkas.neve, "Kiss Jnos");
  munkas.azonositoja = 123456L;       // Long int konstans
  munkas.fizetese = 20000L;           // Long int konstans

  strcpy(fonok1.neve, "Nagy Pter");
  fonok1.azonositoja = 12L;           // Long int konstans
  fonok1.fizetese = 200000L;          // Long int konstans

  // Objektum rtkads
  fonok2 = fonok1;

  // Kiiratas az objektumok metdusval
  munkas.adatkiirasa();
  fonok1.adatkiirasa();
  fonok2.adatkiirasa();
} //main
