/*  GAUSS.H  */
/* teljes felemkivlsztssal Gauss eliminci */

typedef char ftnevg[20];
const int maxnum=10;
typedef double tombg[maxnum+1][maxnum+2];
typedef double vektg[maxnum+1];
typedef int vektgi[maxnum+1];

int gausst(tombg a,int n,fstream& datafileg,char mentg);
void olvas(tombg a,int n,fstream& datafileg,char mentg);
void kiir(tombg a,int n,fstream& datafileg,char mentg);
void gyokkiir(tombg a,int n,fstream& datafileg,char mentg);
void hangg();
void clrbufg();
void clrbufg()
{
        while(cin.get()!='\n');
}

void hangg()
{
        sound(1000);
        delay(30);
        sound(500);
        delay(30);
        nosound();
}
void gauss()
{
  tombg a;
  int n,hiba;
  char mentg;
  int  fileerr=0;
  fstream datafileg;
  ftnevg fnevg;
    _fpreset();

 do{
  gotoxy(3,2);
  cputs("Kvnja majd az adatokat menteni? (I/N)\n");
    do{
        mentg=getch();
        hangg();
        mentg=toupper(mentg);
    }while((mentg!='I') && (mentg!='N'));
    if (mentg=='I')
    {
        gotoxy(3,3);
        cputs("Krem adja meg a file nevt az elrsi ttal egytt! ");
        gotoxy(3,4);
        cin>>fnevg;
        hangg();
        clrbufg();
        datafileg.open(fnevg,ios::out);
        if(datafileg.fail())
        {
          cputs("A file mvelet nem sikerlt!");
          fileerr=1;
          getch();
          hangg();
        }

     }
}while(fileerr==1);
    do
    { window(1,1,80,25);
      textbackground(1);
      clrscr();
      cout<<"Elemek szma [max.10]: "; cin>>n;
      datafileg<<"Elemek szma:"<<n<<endl;
    }
    while (n>10);
    olvas(a,n,datafileg,mentg);
    cout<<endl;
    cout<<"Az n+1 oszloppal kibvitett mtrix";
    if (mentg=='I') datafileg<<endl<<"Az n+1 oszloppal kibvitett mtrix"<<endl;
    cout<<endl<<endl;
    kiir(a,n,datafileg,mentg);
    hiba=gausst(a,n,datafileg,mentg);
    if(hiba)
    {
       cout<<endl;
       cout<<"Az egyenlet nem oldhat meg";
       cout<<endl;

    }
    else
    {
       cout<<endl;
       cout<<"A mdositott mtrix";
       cout<<endl;
       kiir(a,n,datafileg,mentg);
       gyokkiir(a,n,datafileg,mentg);
    }


    if (mentg=='I') datafileg.close();
    getch();
    hangg();

}

int gausst(tombg a,int n,fstream& datafileg,char mentg)
{
  int i,j,k,s,m;
  double t,eps,max,oszt;
  vektgi sor;
  vektg x;
     eps=0.000001;

     /* az elso betoldas*/
     for(i=1;i<=n;i++)
       sor[i]=i;

     /* egyenlet sorrendje azonos a sorindex-szel */
     for(k=1;k<=n;k++)
     {

      /* 2. betolds */
       max=0.0;s=k;m=k;
       for(i=k;i<=n;i++)
         for(j=k;j<=n;j++)
          if(fabs(a[i][j])>max)
          {
            oszt=a[i][j];
            max=fabs(oszt);
            s=i;m=j;
          }

      if(s!=k)
       {
        /* Ha nem a ftlbeli elem a legnagyobb */
         for(i=k;i<=n+1;i++)
         {
           t=a[k][i];
           a[k][i]=a[s][i];
           a[s][i]=t;
         }
       }
       if (m!=k)
       {
       /* Egyenletek sorrendjnek vizsglata */
         for(i=1;i<=n;i++)
         {
           t=a[i][k];
           a[i][k]=a[i][m];
           a[i][m]=t;
         }
         i=sor[k];
         sor[k]=sor[m];
         sor[m]=i;
      }
       t=a[k][k];
       if(fabs(t)>eps)
       {
         cout<<endl;
         cout<<"Oszt: ["<<s<<","<<m<<"] index (max. elemmel):";
         datafileg.setf(ios::fixed);
         datafileg.setf(ios::showpoint);
         datafileg.setf(ios::right);
         if (mentg=='I') datafileg<<endl<<"Oszt: ["<<s<<","<<m<<"] index (max. elemmel):"<<endl;
         cout.setf(ios::fixed);
         setw(5);
         setprecision(2);
         cout<<oszt;
         cout<<endl<<endl;
         t=1.0/t;
         for(i=k;i<=n+1;i++)
           a[k][i]=t*a[k][i];

         if (k!=n)
         {
           cout<<k<<". talakts "<<endl;;
           if (mentg=='I') datafileg<<k<<". talakts"<<endl;
           for(i=k+1;i<=n;i++)
           {
             t=a[i][k];
             for(j=k;j<=n+1;j++)
               a[i][j]=a[i][j]-a[k][j]*t;
           }
         }
       kiir(a,n,datafileg,mentg);
       }
       else return 1;
     }

     for(i=n;i>=1;i--)
     {
        t=a[i][n+1];
        for(k=i+1;k<=n;k++)
           t=t-a[i][k]*a[k][n+1];
        a[i][n+1]=t/a[i][i];
     }
    /* 3. betolds */
    for(i=1;i<=n;i++)
      x[sor[i]]=a[i][n+1];
    for(i=1;i<=n;i++)
      a[i][n+1]=x[i];
  return 0;
}

void gyokkiir(tombg a, int n,fstream& datafileg,char mentg)
{
int i;
   cout<<endl;
   cout<<"Az egyenlet gykei";
   if (mentg=='I') datafileg<<endl<<endl<<"Az egyenlet gykei"<<endl;
   cout<<endl<<endl;
   for(i=1;i<=n;i++)
   {
     cout<<"x"<<i<<" = "<<a[i][n+1]<<endl;
     if (mentg=='I')  datafileg<<"x"<<i<<" = "<<a[i][n+1]<<endl;
   }
}


void olvas(tombg a,int n,fstream& datafileg,char mentg)
{
 int i,j;
  cout<<endl;
  for(i=1;i<=n;i++)
  {
   for(j=1;j<=n;j++)
   {
    cout<<"a["<<i<<","<<j<<"] = "; cin>>a[i][j];
    if (mentg=='I')  datafileg<<endl<<"a["<<i<<","<<j<<"] = "<<a[i][j]<<endl;
   }
    cout<<"Jobb oldal:"<<endl;
    if (mentg=='I') datafileg<<endl<<"Jobb oldal:"<<endl;
    cout<<"b["<<i<<"] = "; cin>>a[i][n+1];
    if (mentg=='I')  datafileg<<"b["<<i<<"] = "<<a[i][n+1]<<endl<<endl;
    cout<<endl;
    if (mentg=='I')  datafileg<<endl;
  }
}

void kiir(tombg a,int n,fstream& datafileg,char mentg)
{
 int i,j;
  if (n>8)
  {
   for(i=1;i<=n;i++)
   {
     for(j=1;j<=n;j++)
     {
       cout<<"a["<<i<<", "<<j<<"] = "<<a[i][j]<<endl;
       if (mentg=='I') datafileg<<"a["<<i<<", "<<j<<"] = "<<a[i][j]<<endl;
     }
     cout<<"b["<<i<<"] = "<<a[i][n+1]<<endl;
     if (mentg=='I') datafileg<<"a["<<i<<", "<<j<<"] = "<<a[i][j]<<endl;
   }
  }
  else
  {
   for(i=1;i<=n;i++)
   {
     for(j=1;j<=n+1;j++)
     {
       setw(5);
       setprecision(2);
       cout.setf(ios::fixed);
       cout.setf(ios::right);
       cout.setf(ios::showpoint);
       cout<<a[i][j]<<"  ";
       datafileg.setf(ios::fixed);
       datafileg.setf(ios::right);
       datafileg.setf(ios::showpoint);
       if (mentg=='I') datafileg<<a[i][j]<<"  ";

     }
     if (mentg=='I') datafileg<<endl;
     cout<<endl;
   }
  }
}