/* Program TX011.c */
/*---------------------------------------------------------------------*/
/* Folyamatos-tlag meghatrozsa                                      */
/*---------------------------------------------------------------------*/
/* A matematikai modell:                                               */
/* Az x1, x2, ... xk, ... sorozat k-adik tagjnl az addigi elemek     */
/* tlaga:  a(k) = ((k-1)*a(k-1) + xk) / k                             */
/*---------------------------------------------------------------------*/
/* Az utols javts dtuma: 2000.02.21.                               */
/*---------------------------------------------------------------------*/

/*--------------------------------------------------------------*/
/* A hivatkozott deklarcis file-ok                            */
/*..............................................................*/
#include <stdio.h>    /* printf, scanf                          */
#include <conio.h>    /* getche                                 */
#include <ctype.h>    /* toupper                                */
/*--------------------------------------------------------------*/

void main() /* A fprogram */
{
  double        x, atlag;
  int           index;
  char          folytatja;

  index = 1;
  atlag = 0;
  do {
      printf("Adja meg a(z) %d-ik szmot: ",index); scanf("%lf",&x);
      atlag = (double)((index-1) * atlag + x) / index;
      printf("A(z) %d-ik tlag: %.11f", index, atlag); printf("\n");
      index = index + 1;
      do {
          printf("folytatja? (I/N) : ");
          folytatja = getche(); printf("\n");
          folytatja = toupper(folytatja);
         } while (!(folytatja =='I' || folytatja == 'N'));
     } while ( folytatja != 'N');
}

/*
A program futtatsa:
--------------------

Adja meg a(z) 1-ik szmot: 1
A(z) 1-ik tlag: 1.00000000000
folytatja? (I/N) : i
Adja meg a(z) 2-ik szmot: -1
A(z) 2-ik tlag: 0.00000000000
folytatja? (I/N) : i
Adja meg a(z) 3-ik szmot: 2
A(z) 3-ik tlag: 0.66666666667
folytatja? (I/N) : i
Adja meg a(z) 4-ik szmot: -2
A(z) 4-ik tlag: -0.00000000000
folytatja? (I/N) : n
*/
