/* Program TX013.c */
/*---------------------------------------------------------------------*/
/* Vektor elemek fordtott sorrendjnek ellltsa                    */
/* vektorduplzs nlkl, fggvnyhasznlattal.                        */
/*---------------------------------------------------------------------*/
/* Az utols javts dtuma: 2000.02.28.                               */
/*---------------------------------------------------------------------*/

/*--------------------------------------------------------------*/
/* A hivatkozott deklarcis file-ok                            */
/*..............................................................*/
#include <stdio.h>    /* printf, scanf                          */
#include <math.h>     /* floor                                  */
/*--------------------------------------------------------------*/

/*----------------------------*/
/* A program modulstruktrja */
/*............................*/
/* TCx13.cpp                  */
/*----------------------------*/

/*--------------------------------------*/
/* Globlis azonostk                  */
/*......................................*/
const int        MAX = 9;
typedef char     vektortipus[MAX];
/*--------------------------------------*/

/*------------------------------------------------------*/
/* E modul fggvnystruktrja (prototipusok)           */
/*......................................................*/
void main(void);
  void feltolt(vektortipus&);
  void kiir1(vektortipus&);
  void kiir2(vektortipus&);
  void megfordit(vektortipus&);
  void kiir3(vektortipus&);
/*------------------------------------------------------*/

void feltolt(vektortipus& avektor)
/* A vektor feltltse */
{
  int       index;

  for (index = 0; index <= (MAX-1); index = index+1)
    {
     printf("A vektor %d-ik karaktere:",index);
     scanf("%1s", &avektor[index]);
    }
  printf("\n") ;
} /* feltolt */

void kiir1(vektortipus& bvektor)
/* A vektor fordtott kiratsa I. */
{
  int       index;

  for (index = 0; index <= (MAX-1); index = index+1)
    printf("%1c", bvektor[(MAX-1)-index]);
  printf("\n");
} /* kiir1 */

void kiir2(vektortipus& cvektor)
/* A vektor fordtott kiratsa II. */
{
  int       index;

  for (index = (MAX-1); index >= 0; index = index-1)
    printf("%1c", cvektor[index]);
  printf("\n");
} /* kiir2 */

void megfordit(vektortipus& dvektor)
/* A vektor megfordtsa */
{
  int       index;
  char      atmenet;

  for (index = 0;  index <= floor((MAX-1)/2); index = index+1)
    {
     atmenet = dvektor[index];
     dvektor[index] = dvektor[(MAX-1)-index];
     dvektor[(MAX-1)-index] = atmenet;
    }
} /* megfordit */

void kiir3(vektortipus& evektor)
/* A megfordtott vektor kiratsa */
{
  int       index;

  for (index = 0; index <= (MAX-1); index = index+1)
    printf("%1c", evektor[index]);
  printf("\n");
}  /* kiir3 */

void main()  /* A fprogram */
{
  vektortipus        xvektor;

  /* Vektorfeltlts */
  feltolt(xvektor);

  /* A vektor fordtott kiratsa I.  */
  kiir1(xvektor);

  /* A vektor fordtott kiratsa II. */
  kiir2(xvektor);

  /* A vektor megfordtsa */
  megfordit(xvektor);

  /* A megfordtott vektor kiratsa */
  kiir3(xvektor);
}

/*
A program futtatsa:
--------------------

A vektor 1-ik karaktere: A
A vektor 2-ik karaktere: B
A vektor 3-ik karaktere: C
A vektor 4-ik karaktere: D
A vektor 5-ik karaktere: E
A vektor 6-ik karaktere: F
A vektor 7-ik karaktere: G
A vektor 8-ik karaktere: H
A vektor 9-ik karaktere: I

IHGFEDCBA
IHGFEDCBA
IHGFEDCBA
*/
