// Program TX022.c
// FELADAT:
// Sztvlogats egy T tulajdonsg alapjn kt msik tmbbe.
// MEGOLDS:
// 1. Beolvas eljrs ( Az eredeti sztvlogatni val tmbre)
// 2. Fgvny, amely eldnti egy-egy eredeti tmbelemrl,
//    hogy megfelel-e a T tulajdonsgnak.
// 3. Pakol eljrs, amely egy-egy tmbelemet egy j tmbbe tesz.
// 4. Kiir eljrs, amely egy tmbt kiir.

#include <stdio.h>
#include <math.h>
typedef int vektortipus[20];
int mod(int, int );
vektortipus eredeti, megfelelt, nem_megfelelt;
int futo_index;

inline int mod(int a, int b)      //sajt modulo fggvny
{
  int mar;
  mar = a - floor(a/b) * b;
  return mar;
}                         // mod fggvny vge

void beolvas( int meret, vektortipus& tomb)   // beolvas eljrs
{
  int i;
  for(i = 0; i <= (meret-1); i = i +1)
    {
    printf("Add meg az %d-edik elemet : " ,i);
    scanf("%d",&tomb[i]);
    printf("\n");
    }
}            // beolvas eljrs vge

char eldont(int szam,int egy_eredeti)        // eldnt fggvny
{
  if(mod( egy_eredeti,szam) == 0)
         return 'I';
     else
         return 'N';
}     //eldont fggvny vge, visszatrsi rtke I vagy N karakter

void pakol( int& index, vektortipus& tomb )  //pakol eljrs
                //  cmszerint paramtertadssal
{               //  egy fiktiv tmbbe betesz az indexedik helyre egy
                //  elemet
  index = index + 1;
  tomb[index] = eredeti[futo_index];
}

void kiir(int vegindex,vektortipus& tomb)   //kiir eljrs
               // Egy cmrl egy tmbt  vgindexig   kiir.
{
  int i;
  for(i = 0; i <= vegindex  ;  i = i + 1)
     printf("%5d",tomb[i]);
  printf("\n");
}             // kiir eljrs vge



void main()
{
  int n, igen_index, nem_index;
  int oszto  ;

  printf("Add meg az elemek szmt :  ");
  scanf("%d",&n);
  beolvas(n, eredeti);

  printf(" Add meg a T tulajdonsgot, azaz az osztt: ");
  scanf("%d", &oszto);

  igen_index = -1;
  nem_index  = -1;

  for (futo_index = 0; futo_index <= (n-1); futo_index = futo_index + 1 )
     if (eldont(oszto, eredeti[futo_index]) == 'I')
        pakol(igen_index,megfelelt);
       else
        pakol(nem_index ,nem_megfelelt);

  printf("Az eredeti tmb rtkei :\n");
  n = n-1;
  kiir(n, eredeti);

  printf(" A T tulajdosgnak megfelelt tomb elemei :\n ");
  kiir(igen_index, megfelelt);

  printf(" A T tulajdonsgnak nem megfelelt tmb elelemi :\n");
  kiir(nem_index,nem_megfelelt);
}

// A program futtatsa:
// ------------------------
// Add meg az elemek szmt : 8

// Add meg az 0-edik elemet : 100
// Add meg az 1-edik elemet : 11
// Add meg az 2-edik elemet : 33
// Add meg az 3-edik elemet : 77
// Add meg az 4-edik elemet : 3
// Add meg az 5-edik elemet : 9
// Add meg az 6-edik elemet : 47
// Add meg az 7-edik elemet : 999

// Add meg a T tulajdonsgot, azaz az osztt: 3
// Az eredeti tmb rtkei :
// 100   11   33   77    3    9   47  999
//  A T tulajdosgnak megfelelt tomb elemei :
//  33    3    9  999
// A T tulajdonsgnak nem megfelelt tmb elelemi :
// 100   11   77   47

