// Program TC011.cpp 
//---------------------------------------------------------------------
// Folyamatos-tlag meghatrozsa
//---------------------------------------------------------------------
// A matematikai modell:
// Az x1, x2, ... xk, ... sorozat k-adik tagjnl az addigi elemek
// tlaga:  a(k) = ((k-1)*a(k-1) + xk) / k
//---------------------------------------------------------------------
// E program egyben plda a cin s cout adatfolyam-objektumokkal val
// formzott kiratsra is.
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.03.19.
//---------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <iostream.h>   // cin, cout
#include <ctype.h>      // toupper
//--------------------------------------------------------------

/**********/
void main()
/**********/
{
  double        x, atlag;
  int           index;
  char          folytatja;

  index = 1;
  atlag = 0;
  do { cout << "Adja meg a(z) "<< index << "-ik szmot: ";
       cin >> x;
       // A lebegpontos munkaterlet lefoglalsa rdekben
       // a szorzat els tnyezje lebegpontos kell legyen:
       atlag = (atlag * (index-1) + x) / index;
       cout << "A(z) " << index  << "-ik tlag: ";

       // FORMZOTT KIIRATS:
       //----------------------------------------------
       // (Az ios::<formtumjelz> megadsban az ios::
       //  az ios adatfolyam objektumosztlyt jelzi)
       //----------------------------------------------
       // A kirats legyen fixpontos (s ne normlalak)
       cout.setf(ios::fixed);
       // A kirats legyen balratmrtett
       cout.setf(ios::left);
       // A kirsi pontossg legyen 11 tizedes
       cout.precision(11);
       // A double tpus adat kiratsa
       cout << atlag;
       // A kirats utn legyen jsorkezds (CR-LF)
       cout << endl;

       index++;   // index = index + 1
       do { cout << "folytatja? (I/N) : ";
            cin >> folytatja;
            folytatja = toupper(folytatja);
          } while (!(folytatja =='I' || folytatja == 'N'));
     } while ( folytatja != 'N');
}

/*
A program futtatsa:
--------------------

Adja meg a(z) 1-ik szmot: 1
A(z) 1-ik tlag: 1
folytatja? (I/N) : i
Adja meg a(z) 2-ik szmot: -1
A(z) 2-ik tlag: 0
folytatja? (I/N) : i
Adja meg a(z) 3-ik szmot: 2
A(z) 3-ik tlag: 0.66666666667
folytatja? (I/N) : i
Adja meg a(z) 4-ik szmot: -2
A(z) 4-ik tlag: -0
folytatja? (I/N) : n
*/
