// Program TC020-1.cpp                                                    
//----------------------------------------------------------------------
// A buborkos rendezs szemlltetse  ( nvekven rendez! )            
//----------------------------------------------------------------------
// Az utols javts dtuma: 2000.03.16.
//----------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <iostream.h>   // cin, cout
//--------------------------------------------------------------

//--------------------------------------
// Globlis azonostk                  
//......................................
const int        MAX  =  6;           // A tmbmret definilsa
const char       IGEN = 'I';
const char       NEM  = 'N';

typedef char     tombtipus[MAX];      // A tmbtpus definilsa
//--------------------------------------

//------------------------------------------------------
// E modul fggvnystruktrja (prototipusok)
//......................................................
//void main();
    void feltolt(tombtipus&);
    void kiir(tombtipus&);
    void rendez(tombtipus&);
//  void kiir(tombtipus&);
//------------------------------------------------------

//--------------------------------
//     A fggvny defincik
//--------------------------------

void feltolt(tombtipus&  a)
// Tmbfeltlts 
{
  int    index  ;
  for (index = 0; index < MAX; index++)
    {
      cout << "A vektor " << index << "-ik karaktere: ";
      cin >> a[index];
    }
}  // feltolt

void kiir(tombtipus&  b)
// A tmb kiratsa
{
  int    index ;
  for (index = 0; index < MAX; index++)
    cout << b[index];
  cout << "\n";
}  // kiir

void rendez(tombtipus&  c)
// A tmb rendezse
{
  int    index;
  char   munka;
  char   voltcsere;

  do {
      voltcsere = NEM ;
      for (index = 1; index < MAX; index++)
	if (c[index] < c[index - 1] )
	  {
	   voltcsere    = IGEN  ;
	   munka        = c[index];
	   c[index]     = c[index - 1];
	   c[index - 1] = munka ;
	  }
      kiir(c);
     } while (voltcsere != NEM);
}  // rendez

/**********/
void main()
/**********/
{
  tombtipus    tomb;

  // Tmbfeltlts
  feltolt(tomb);
  cout << "\n";

  // A feltlttt tmb kiratsa 
  cout << "A feltlttt tmb:\n";
  kiir(tomb);
  cout << "\n";

  // A tmb rendezse 
  cout << "A tmb rendezsnek fzisai:\n";
  rendez(tomb);
  cout << "\n";

  // A rendezett tmb kiratsa 
  cout << "A rendezett tmb:\n";
  kiir(tomb);
}

/*
A program futtatsa:
--------------------

A vektor 0-ik karaktere: A
A vektor 1-ik karaktere: S
A vektor 2-ik karaktere: A
A vektor 3-ik karaktere: P
A vektor 4-ik karaktere: K
A vektor 5-ik karaktere: A

A feltlttt tmb:
ASAPKA

A tmb rendezsnek fzisai:
AAPKAS
AAKAPS
AAAKPS
AAAKPS

A rendezett tmb:
AAAKPS
*/
