// Program TC041.cpp
//---------------------------------------------------------------------
// Alapmveletek stringekkel I.
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.03.29.
//---------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <iostream.h>   // cin, cout
#include <string.h>     // strcpy, strlen, strcat
//--------------------------------------------------------------

/**********/
void main()
/**********/
{
  char     forras1[] = "abcd";
  char     forras2[] = "1234";
  char     eredmeny[40];
  int      hossz;

  // STRING KIIRATS S RTKADS STRING-BEOLVASSSAL:
  cout << "Adjon meg egy szveget (kezddhet szkzzel is): ";
  // A vezet szkzk, tabultor s sorvgjelek levgsa
  // a ws io-manipultorrral (ezt beolvass kell kvesse)
  cin >> ws;
  cin.getline(eredmeny, sizeof(eredmeny));
  cout << "A beolvass eredmnye =" << eredmeny << "=\n";

  // STRING RTKADS STRINGKONSTANSSAL:
  strcpy(eredmeny, "Ez egy szvegkonstans");
  cout << eredmeny << "\n";

  // STRING RTKADS STRINGVLTOZVAL (string msols):
  strcpy(eredmeny, forras1);
  cout << "A forrs string = " << forras1;
  cout << ", a cl string (az rtkads utn) = " << eredmeny << "\n";

  // STRING HOSSZNAK MEGLLAPITSA:
  hossz = strlen(forras1);
  cout << "A forrs string hossza : " << hossz << "\n";

  // STRINGEK LNCOLSA:
  // 1. String inicializlsa res stringgel
  strcpy(eredmeny, NULL);    
     // A string inicializls a NULL nev, 0 rtk rendszerkonstanssal
     // trtnt olymdon, hogy mivel az strcpy a msodik operandus helyn
     // egy, legalbb egy hosszsg karaktersorozatot vr, gy az ott 
     // szerepl nulla rtk konstanst egy nulla kd karakterr konver-
     // tlta automatikusan. Ez a nulla kd karakter pedig a stringmve-
     // letekben olymdon viselkedik, mint egy olyan string, mely csak a 
     // stringlezr ('\0') karaktert tartalmazza, vagyis mint az("\0") 
     // "res" string.
  // 2. A forras1 string hozzfzse az "res" eredmny stringhez   
  strcat(eredmeny, forras1);
  // 3. A forras2 string hozzfzse az eredmny stringhez   
  strcat(eredmeny, forras2);
  // A fent bemutatott mdszer alkalmas stringek ciklikus sszefzsre
  // olymdon, hogy a ciklus eltt a clstringet inicializljuk,
  // majd a ciklusban ehhez mindig hozzfzzk a tovbbi stringeket.
  // Kirats:
  cout << "Az egyik forrs string = " << forras1 << "\n";
  cout << "A msik forrs string  = " << forras2 << "\n";
  cout << "          A lncolatuk = " << eredmeny << "\n";

} //main
