// Program TC055.cpp
//---------------------------------------------------------------------
// Objektumhasznlat
// Objektum rklds
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.04.13.
//---------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <iostream.h>   // cin, cout
#include <string.h>     // strcpy
//--------------------------------------------------------------

//--------------------------------------
// Globlis azonostk
//......................................
class dolgozo
{
  private:
    typedef char     nev_tipus[20];

  public:
    nev_tipus        neve;              // Adattag
    long int         azonositoja;       // Adattag
    long int         fizetese;          // Adattag
    
    void adatkiirasa()                  // Bels metdus
    {
      cout << "Nv       : " << neve        << "\n";
      cout << "Azonost : " << azonositoja << "\n";
      cout << "Fizets   : " << fizetese    << "\n";
      cout << "\n";
    }; // adatkiirasa
}; // dolgozo

class dolgozo_utod : public dolgozo    // public  : az rklds jellege
{                                      // dolgozo : az s (akitl rkl)
  private:
    typedef char     betegseg_tipus[60];

  public:
    betegseg_tipus   betegsegei;        // Uj adattag
    
    void spec_adatai()                  // Uj bels metdus
    {
      cout << "Nv        : " << neve        << "\n";
      cout << "Azonost  : " << azonositoja << "\n";
      cout << "Betegsgei : " << betegsegei  << "\n";
      cout << "\n";
    }; // spec_adatai
}; // dolgozo_utod
//--------------------------------------

/**********/
void main()
/**********/
{
  dolgozo_utod    munkas;        // A szrmaztatott osztly objektuma

  // rtkads az objektum adattagjainak
  strcpy(munkas.neve, "Kiss Jnos");
  munkas.azonositoja = 123456L;
  munkas.fizetese = 20000L;    
  strcpy(munkas.betegsegei, "ktoldali flhalls, krnikus zseblz");

  // Kiiratas az objektumok metdusaival
  munkas.adatkiirasa();   // Az eredeti objektum metdusa
  munkas.spec_adatai();   // A szrmaztatott objektum metdusa
} //main
