// Program TC061.cpp
//---------------------------------------------------------------------
// String algoritmusok (Alstring keress)
//.....................................................................
// Alstring keress alstring kijellssel (kiemels nlkl)
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.04.15.
//---------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <iostream.h>   // cin, cout
#include <string.h>     // strcpy, strlen, strncmp
#include <conio.h>      // clrscr
//--------------------------------------------------------------

//--------------------------------------
// Globlis azonostk                  
//......................................
const int       MAX = 30;           // A leghosszabb szveg hossza + 1
typedef char    szoveg_tipus[MAX];  // A szvegtpus definilsa
//--------------------------------------

//--------------------------------
//     A fggvny defincik
//--------------------------------

void clrbuf()
// Trli a billentyzet puffert
{while (cin.get() != '\n');}

/**********/
void main()
/**********/
{
  szoveg_tipus  kulcs, minta;
  int           kulcs_hossz;
  int           minta_hossz;
  int           index, hatar;
  int           pozicio;


  // A kperny trlse
  clrscr();


  // ALSTRING KERESS
  // ================
  // Keresi a kulcsszveget a mintaszvegben
  
  // 1. A KULCSSZVEG BEKRSE
  cout << "Adja meg a kulcsszveget (amelyet keresni akar): ";
  // A vezet whitespace karakterek (szkzk, tabultor s sorvgjelek)
  // levgsa a ws io-manipultorral (ezt beolvass kell kvesse)
  cin >> ws;
  // 1.2. A kulcsszveg beolvassa
  cin.getline(kulcs, sizeof(kulcs));
  // 1.3. Ha a bert szveg az engedlyezettnl hosszabb volt,
  //      akkor trli a billentyzetpufferben maradt karaktereket
  //      (egszen a bevitelt lezr Enter-ig).
  if (cin.gcount() >= sizeof(kulcs)-1)      clrbuf();
  // 1.4. Kirats
  cout << "A beolvass eredmnye =" << kulcs << "=\n";

  // 2. A MINTASZVEG BEKRSE
  cout << "Adja meg a mintaszveget (amelyben keresni akar): ";
  cin >> ws;
  cin.getline(minta, sizeof(minta));
  if (cin.gcount() >= sizeof(minta)-1)      clrbuf();
  cout << "A beolvass eredmnye =" << minta << "=\n";

  // 3. A HOSSZELLENRZS
  // 3.1. A kulcsszveg hossznak megllaptsa
  kulcs_hossz = strlen(kulcs);
  // 3.2. A mintaszveg hossznak megllaptsa
  minta_hossz = strlen(minta);
  // 3.3. Ellenrzs
  if (kulcs_hossz > minta_hossz)
    { cout << "A kulcs nem alstringje a mintnak!" << endl;
      cout << "(A kulcs hosszabb a mintnl)" << endl;
      // Kiugrs a programbl
      return;
    }  

  // 4. A KULCSSZVEG KERESSE A MINTASZVEGBEN
  // 4.1. A tallati pozci inicializlsa
  //      (Ha nem tall, akkor ez marad)
  pozicio = -1;
  // 4.2. A keressi hatr meghatrozsa a mintaszvegben
  hatar = minta_hossz - kulcs_hossz + 1;
  // 4.3. A minta ciklikus keresse a kulcsban
  for (index = 0; index < hatar; index++)
    { // 4.3.1. STRING HASONLITS (alstring kijellssel):
      // A kulcsszveg sszehasonltsa a vele azonos hosszsg,
      // mintban kijellt alstringgel.
                // A kijells olymdon trtnik, hogy a kijells
                // kezdpozcijaknt a minta tmb index-edik elemnek
                // cmt adja meg.
                // Az alstring kijells gyorsabb (s egyszerbb is),
                // mint az alstring kiemelsi mdszer.
      if ( strncmp(kulcs, &minta[index], kulcs_hossz) == 0 )
        // Ekkor sikeres volt az egyezsg-vizsglat
        { pozicio = index;
          // Kiugrs a ciklusbl
          break;
        }
    }

  // 5. A KERESS EREDMNYNEK KIIRATSA
  if (pozicio > -1)
    { cout << "A kulcs a(z) " << (pozicio+1);
      cout << "-ik karaktertl kezdden alstringje a mintnak!" << endl;
    }
  else
    cout << "A kulcs nem alstringje a mintnak!" << endl;
} //main
