// Program TC102.cpp                                      (flves.cpp)
//---------------------------------------------------------------------
// CD katalgus
// Herhof Attila I.ves villamosmrnk hallgat (V/25 tk.) munkja
//.....................................................................
// Az adatllomny az aktulis alknyvtr TC102.DAT file-ja
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.05.12.
//---------------------------------------------------------------------

//************* Flves Program ********************
//*************** Cd katalogus *********************
//           Ksztette:Herhof Attila
//                  Tankr V/25
//           Utols javts: 2000.05.07.

#include <iostream.h>
#include <ctype.h>
#include <iomanip.h>
#include <conio.h>
#include <stdio.h>    //remove, rename
#include <stdlib.h>
#include <fstream.h>
#include <string.h>


const int MAXNEV=26;                   // A nev max hosza
const int MAXCIM=26;                   // A cim max hossza
const int DATEMAX=5;                   // A datum max. hossza
const int STILMAX=14;                  // A stilus max. hosza
const int STILDB=18;                   // A stilusok darabszama
const int DATUMMIN=1900;               //Ennel kisebb datumu nem lenet
const int DATUMMAX=2000;               //Ennl ksbbi dtumu nem lehet
const char  fnev[]="TC102.dat";
const char  ftmp[]="TC102.tmp";
const char stilus[STILDB][STILMAX] = { "komolyzene","kortrs zene","rock","heavy metal","pop","jazz","latin","alternativ","filmzene","folk-npzene","funky","techno","disko","country","etno","ir npzene","world music","egyb",};
struct rekord { char eloado[MAXNEV];
		char lemezcim[MAXCIM];
                int date;
                int stilkod;};

// void main ();                        //Eljrsok
   void fomenu(int&);                   //Fmen
   void signal();                       //Kezdkp
   void alapkep();                      //Alapkperny belltsa
   void bill1();                        //Egy bill. lenyomst rzkel s tovbblp
   void kereses();                      //Keressi md kivlasztsa
   void adatok();                       //Adatvltoztats (trls,bevitel)
   void torles();                       //Adatok trlse
   void adatbe();                       //j adat bevitele
   void lista();                        //Teljes listzs
   void info();                         //Informci a programrl
   void kilepes(char&);                 //Kilps
   void eloszer();                      //Elad szerinti keress
   void cimszer();                      //Cm szerinti keress
   void datszer();                      //Dtum szerinti keress
   void stilszer();                     //Stilus szerinti keress
   void valaszt(int&,int);              //Menpont kivlasztsa
   void keret();                        //Nagy csillagos keret rajzolsa
   void kiskeret();                     //Kis csillagos keret rajzolsa
   void betubeir(int,int,int);          //Betbeirs adott hosszon, adot poziciban
   void clrbuff();                      //Bill. puffer
   void stilmat(int);                   //A stlusok mtrixszer kiiratsa
   void hiba();                         //Fjlkezelsi hiba
   void listakep();                     //Listzsi kp
   void keres(int, fstream);            //Valdi keress, int kdja alapjn
   void sorkiir(int,int,rekord);        //Egy sor kirsa a listban
   void ellenoriz(rekord);              //Kiirats ellenrzsre


void clrbuff()                          //Bill. puffer trl
  {
  while(cin.get()!='\n');
  }


void bill1()                   //Egy billenty lenyomst rzkel
 {
   _setcursortype(_NOCURSOR);
   getch();
   _setcursortype(_NORMALCURSOR);         // s resen tovblp
 }


void alapkep()                         //Alapkperny (ablak) belltsa
 {
  textcolor(0);textbackground(0);
  window(1,1,80,25);clrscr();
 }


void signal()                         //Kezdkp (signal)
  {
   alapkep();
   textbackground(8);textcolor(6);clrscr();
   gotoxy(30,3); cout << "********     ********";
   gotoxy(28,4); cout << "**********     **********";
   gotoxy(27,5); cout << "***             **      ***";
   gotoxy(27,6); cout << "***             **      ***";
   gotoxy(27,7); cout << "***             **      ***";
   gotoxy(28,8); cout << "**********     **********";
   gotoxy(30,9); cout << "********     ********";
   gotoxy(32,12); cout << "K A T A L O G U S";
   textcolor(1);window(28,16,52,18);clrscr();
   gotoxy(1,1); cout << "Ksztette: Herhof Attila";
   gotoxy(7,3); cout << "2000. prilis";
   textcolor(9);window(13,24,70,24);clrscr();
   gotoxy(2,1); cout << "A program elkezdshez krem nyomjon meg egy billentyt!\n\n";
   bill1();
   }


void keret()                          //Alapkeret megrajzolsa (12,3,68,20)
   {
    int i;
    textcolor(6);clrscr();
     for (i=3;i<21;i++)
      {
       gotoxy(12,i);cout << "*";gotoxy(68,i); cout << "*";
      }
     for (i=14;i<68; i=i+2)
      {
       gotoxy(i,3);cout <<  "*";gotoxy(i,20); cout << "*";
      }
    textcolor(1);window(32,18,48,18);clrscr();
    gotoxy(1,1); cout << "Krem vlasszon!";
   }


void kiskeret()                         //Kiskeret megrajzolsa
  {
   window(22,2,58,4);textcolor(6);clrscr();
   gotoxy(1,1);cout << "* * * * * * * * * * * * * * * * * * *";
   gotoxy(1,2);cout << "*                                   *";
   gotoxy(1,3);cout << "* * * * * * * * * * * * * * * * * * *";
   window(23,3,57,3);textcolor(9);clrscr();
  }


void fomenu(int& val)      // ************Kezd indtmen*************
 {
  alapkep();
  keret();
  textcolor(9);window(27,5,56,15);clrscr();
  gotoxy(9,1);  cout << "F  m e n ";
  gotoxy(5,2);  cout << "-------------------";
  gotoxy(1,6);  cout << "1 - Keress a katalgusban";
  gotoxy(1,7);  cout << "2 - Adat bevitele vagy trlse";
  gotoxy(1,8);  cout << "3 - A katalgus kilistzsa";
  gotoxy(1,9);  cout << "4 - Informci";
  gotoxy(1,10); cout << "5 - Kilps";
  valaszt(val,5);
  }


void valaszt(int& mpont,int X)            // A menpontvlaszts lekrdezse
  {                                       // s lekezelse

  _setcursortype(_NOCURSOR);
  do                                     //Lekezels : 1-X-ig legyen a szm
   {
    mpont=getch();
   }
  while( mpont<49 || mpont>(49+X-1));
  _setcursortype(_NORMALCURSOR);
  alapkep();
 }


void kereses()                           // Keress mdok
  {
  int ker,ki=0;

 do
  {
  alapkep();
  keret();
   textcolor(9);window(26,5,61,16);clrscr();
   gotoxy(5,1); cout << "Keress a katalgusban";
   gotoxy(3,2); cout << "--------------------------";
   gotoxy(1,5); cout << "1 - Elad szerinti keress";
   gotoxy(1,6); cout << "2 - Albumcm szerinti keress";
   gotoxy(1,7); cout << "3 - Dtum (v) szerinti keress";
   gotoxy(1,8); cout << "4 - Stlus szerinti keress";
   gotoxy(1,9); cout << "5 - A katalgus teljes listzsa";
   gotoxy(1,10); cout << "6 - Vissza a fmenbe";
   valaszt(ker,6);
   switch (ker)
    {
     case 49:
      alapkep();
      eloszer();
      break;
     case 50:
      alapkep();
      cimszer();
      break;
     case 51:
      alapkep();
      datszer();
      break;
     case 52:
      alapkep();
      stilszer();
      break;
     case 53:
      alapkep();
      lista();
      break;
     case 54:
      ki=1;
      break;
     }
   }
  while(ki!=1);
 }


void betubeir(int x,int y,int h)     //Bet bersa x,y poziciban, h hosszon
  {
   window(x,y,x+h-2,y);textbackground(6);textcolor(14);clrscr();
   gotoxy(1,1);
  }


void keres(int mod, rekord minta)
 {
  int 	     sor=0, filesor=0;
  long int   mutato=0, mut=0;
  int 	     vala;
  char*      talalat;
  rekord     pelda;
  fstream    adatfile;

  adatfile.open(fnev, ios::binary | ios::in);
  vala = 0;
   if ( adatfile.fail() )        hiba();
    while (vala!=32)
     {
      switch (mod)
       {
       case 1:                      //Elad szerint
	 while(! adatfile.eof() && sor<20)
	  {
	   filesor++;
	   adatfile.read((char*)&pelda, sizeof(pelda));
	   talalat=strstr(pelda.eloado,minta.eloado);
	   if (talalat!=NULL)
	     {
	     sor++;
	     sorkiir (filesor,sor,pelda);
	     }
	  }
	 break;
	case 2:                         //Albumcm szerint
	  while(! adatfile.eof() && sor<20)
	  {
	   filesor++;
	   adatfile.read((char*)&pelda, sizeof(pelda));
	   talalat=strstr(pelda.lemezcim,minta.lemezcim);
	   if (talalat!=NULL)
	     {
	     sor++;
	     sorkiir (filesor,sor,pelda);
	     }
	  }
	 break;
	case 3:                        //Dtum szerint
	  while (! adatfile.eof() && sor<20)
	  {
	   filesor++;
	   adatfile.read((char*)&pelda, sizeof(pelda));
	   if (minta.date==pelda.date)
            {
             sor++;
	     sorkiir (filesor,sor,pelda);
            }
          }
	 break;
        case 4:                       //Stilus szerint
          while (! adatfile.eof() && sor<20)
	  {
           filesor++;
           adatfile.read((char*)&pelda, sizeof(pelda));
           if (minta.stilkod==pelda.stilkod)
             {
             sor++;
	     sorkiir (filesor,sor,pelda);
             }
          }
         break;
       }
          while(vala!=32 && vala!=72 && vala!=80)
                    vala=getch();
       if (vala==72)
          {
          filesor=0;sor=0;
          if (filesor<0) filesor=0;
	  clrscr();
          mut=adatfile.tellg();
          adatfile.close();
	  adatfile.open(fnev,ios::binary | ios::in);
	  mutato=0*sizeof(pelda);
	  if (mutato<0) mutato=0;
          adatfile.seekg(mutato, ios::beg);
//        adatfile.read ((char*)&pelda, sizeof(pelda));
          vala=0;
	  }
       if (vala==80)
          {
          sor=0;
          if (adatfile.eof())
             {
             adatfile.seekg(0, ios::beg);
             filesor=1;
             }
          mut=adatfile.tellg();
          adatfile.close();
	  adatfile.open(fnev,ios::binary | ios::in);
          mutato=mut;
          adatfile.seekg(mutato, ios::beg);
          adatfile.read ((char*)&pelda, sizeof(pelda));
          vala=0;
	  }
       clrscr();
     }
  adatfile.close();
 }


void sorkiir(int adatszam,int sor,rekord rekord2)
   {                      //Egy sor kirsa a listban
   gotoxy(1,sor); cout << setw(3) << adatszam << ".";
   gotoxy(6,sor); cout << rekord2.eloado;
   gotoxy(33,sor); cout << rekord2.lemezcim;
   gotoxy(61,sor); cout << rekord2.date;
   gotoxy(66,sor); cout << setw(STILMAX) << stilus[rekord2.stilkod-1];
  }


void eloszer()                      //Elad szerinti keress
  {
  char nev[25];
  rekord nevrekord;
  alapkep();
  kiskeret();
  gotoxy(7,1);cout << "Elad szerinti keress";
  window(3,12,45,13);textcolor(2);clrscr();
  gotoxy(1,1);cout << "Krem rja be a keresend elad nevt !";
  gotoxy(7,2);cout << "(max. 25 karakter)";
  betubeir(2,15,MAXNEV);
  cin >> setw(MAXNEV);
  cin.getline(nev,sizeof(nev));
  if (cin.gcount()>=sizeof(nev)-1)           clrbuff();
  strcpy(nevrekord.eloado,nev);
  listakep();
  keres(1,nevrekord);
 }


void cimszer()                      //Cm szerinti keress
  {
  char cim[MAXCIM];
  rekord cimrekord;
  alapkep();
  kiskeret();
  gotoxy(9,1);cout << "Cm szerinti keress";
  window(3,12,45,13);textcolor(2);clrscr();
  gotoxy(1,1);cout << "Krem rja be a keresend album cmt !";
  gotoxy(5,2);cout << "(max. 25 karakter)";
  betubeir(2,15,MAXCIM);
  cin >> setw(MAXCIM);
  cin.getline(cim,sizeof(cim));
  if (cin.gcount()>=sizeof(cim)-1)           clrbuff();
  strcpy(cimrekord.lemezcim,cim);
  listakep();
  keres(2,cimrekord);
  }


void datszer()                      //Dtum szerinti keress
  {
  char datu[DATEMAX];
  int datumbe;
  rekord datrekord;

  alapkep();
  kiskeret();
  gotoxy(7,1);cout << "Dtum szerinti keress";
  window(3,12,55,13);textcolor(2);clrscr();
  gotoxy(1,1);cout << "Krem rja be a keresend album kiadsi vt !";
  gotoxy(8,2);cout << "(1900-2000-ig)";
  do                                   //Lekezeli a nem szmokat es a
   {                                   //DATUMMIN=nel kisebb szmokat
    betubeir(2,15,DATEMAX);            //s a DATUMMAX-nl nagyobb
    cin >> setw(DATEMAX);              //adatokat
    cin.getline(datu,sizeof(datu));
    if (cin.gcount()>=sizeof(datu)-1)           clrbuff();
    datumbe=atoi(datu);
   }
   while (datumbe<DATUMMIN || datumbe>DATUMMAX);
   datrekord.date=datumbe;
   listakep();
   keres(3,datrekord);
  }


void stilmat(int sor)                                  //For ciklus:
  {                                             //stilusok kiirsa mtrixban
  int x,y,i=0;
  window(1,sor,80,sor+5);textcolor(13);textbackground(0);clrscr();
   for (x=10; x<=60; x=x+25)
    {
       for (y=1; y<=6; y++)
       {
         i++;
         gotoxy(x,y);cout << i << "  "  << stilus[i-1] << "    ";
       }
    }
  }


void stilszer()                     //Stilus szerinti keress
  {
  int st;
  char stil[3];
  rekord stirekord;
  alapkep();
  kiskeret();
  gotoxy(7,1);cout << "Stilus szerinti keress";
  stilmat(9);
  window(20,18,61,18);textcolor(2);clrscr();
  gotoxy(1,1);cout << "Krem rja be a keresend stilus szmt!";
   do
    {
     betubeir(39,20,3);
     cin >> setw(2);
     cin.getline(stil,sizeof(stil));
     if (cin.gcount()>=sizeof(stil))           clrbuff();
     st=atoi(stil);
    }
   while (st<1 || st>STILDB);
   stirekord.stilkod=st;
   listakep();
   keres(4,stirekord);
  }


void adatok()                      //Adatvltoztats-trls,bevitel
  {
  int adval,vissza=0;
  do
  {
  alapkep();
  keret();
  textcolor(9);window(28,5,53,14); clrscr();
  gotoxy(2,1); cout << "Adatok bevitele, trlse";
  gotoxy(1,2); cout << "--------------------------";
  gotoxy(3,7); cout << "1 - Uj adat bevitele";
  gotoxy(3,8); cout << "2 - Adatok trlse";
  gotoxy(3,9); cout << "3 - Vissza a fmenhz";
  valaszt(adval,3);
  switch (adval)
   {
   case 49:
     adatbe();
     break;
   case 50:
     torles();
     break;
   case 51:
     vissza=1;
     break;
     }
   }
   while (vissza!=1);
  }


void torles()                      //Adatok trlse
  {
  char      sorszam[4];
  int       sora=0, torol, index=0;
  long int  maxadat=0;
  long int  mutat;
  fstream   datafile, torolt;
  rekord    torlendo, masol;
  alapkep();
  kiskeret();
  window(33,3,47,3);textcolor(9);clrscr();
  gotoxy(1,1); cout << "Adatok trlse";
  window(3,6,65,6);textbackground(0);textcolor(2);clrscr();
      datafile.open(fnev, ios::in | ios::ate);  //Adatok megszmolsa
      maxadat=datafile.tellg()/sizeof(masol);
      datafile.close();
  gotoxy(7,3); cout << "Krem adja meg a trlni kvnt adat sorszmt ";
  cout << "(max."<< maxadat << ") :";
     do
      {
       betubeir(2,7,4);
       cin >> ws >> setw(3);
       cin.getline(sorszam,sizeof(sorszam));
       if (cin.gcount()>=sizeof(sorszam))           clrbuff();
       sora=atoi(sorszam);
      }
      while (sora<1 || sora>maxadat);
  datafile.open(fnev, ios::binary | ios::in);
      if (datafile.fail())         hiba();
  mutat=(sora-1)*sizeof(torlendo);
   datafile.seekg(mutat, ios::beg);
   datafile.read((char*)&torlendo, sizeof(torlendo));
   ellenoriz(torlendo);
   datafile.close();
  window(26,20,55,20);textcolor(12);
  textbackground(0);clrscr();
  cout << "Biztosan kvnja trlni(I/N)?";
  _setcursortype(_NOCURSOR);
  torol = 0;
  while (torol!=73 && torol!=78)  torol=toupper(getch());
  if (torol==73)
     {
      datafile.open(fnev, ios::binary | ios::in);
      torolt.open(ftmp, ios::binary | ios::out);
       if (torolt.fail())         hiba();
      while(sora!=index+1)       //Elttelv trlse
       {index=index+1;
        mutat=(index-1)*sizeof(masol);
        datafile.read((char*)&masol, sizeof(masol));
        torolt.write((char*)&masol,sizeof(masol));
       }
      mutat=(index+1)*sizeof(masol);
      datafile.seekg(mutat, ios::beg);
        datafile.read((char*)&masol, sizeof(masol));
      while(!datafile.eof())     //utnalv trlse
	{
        torolt.write((char*)&masol, sizeof(masol));
        datafile.read((char*)&masol, sizeof(masol));
        }
       datafile.close();
       torolt.close();
      remove(fnev);
      rename(ftmp, fnev);
      window(32,23,49,23);textcolor(10),textbackground(12);clrscr();
      cout << "Az adat trlve!!!";
     bill1();
     }
  _setcursortype(_NORMALCURSOR);
  }


void ellenoriz(rekord ellenor)            //Kiirats ellenrzsre
   {
    window(1,6,80,24); textbackground(0); textcolor(2);
    clrscr(); window(17,10,35,13);clrscr();
    gotoxy(1,1); cout << "Elad:"; gotoxy(1,2); cout << "Album cme:";
    gotoxy(1,3); cout << "Kiads ve:"; gotoxy(1,4); cout << "Stlus:";
    window(38,10,63,13); textcolor(14);clrscr();
    gotoxy(1,1); cout << setw(MAXNEV) << ellenor.eloado;
    gotoxy(1,2); cout << setw(MAXNEV) << ellenor.lemezcim;
    gotoxy(1,3); cout << setw(MAXNEV) << ellenor.date;
    gotoxy(1,4); cout << setw(MAXNEV) << stilus [ellenor.stilkod-1];
  }


void adatbe()                     //Adatbevitel
  {
   char nev[MAXNEV], cim [MAXCIM], stils [3], datum[DATEMAX],ok;
   int sti,datumbe,kilep=0,meret1,meret2,meret,i;
   rekord kiadat,beadat;
   fstream ujfile,regifile;
  do
   {
   alapkep();
   kiskeret();
   gotoxy(11,1);cout << "j adat bevitele";
      window(3,6,55,6);textbackground(0);textcolor(2);clrscr();
      gotoxy(1,1);cout << "Krem az j elad nevt (max. 25 karakter) :";
      betubeir(2,7,MAXNEV);
      gotoxy(1,1);cin >> ws >> setw(MAXNEV);
      cin.getline(nev,sizeof(nev));
     if (cin.gcount()>=sizeof(nev)-1)           clrbuff();
      window(3,8,47,8);textbackground(0);textcolor(2);clrscr();
      gotoxy(1,1);cout << "Krem az j album cmt (max. 25 karakter) :";
      betubeir(2,9,MAXCIM);
      gotoxy(1,1);cin >> setw(MAXCIM);
      cin.getline(cim,sizeof(cim));
     if (cin.gcount()>=sizeof(cim)-1)           clrbuff();
      window(3,10,45,10);textbackground(0);textcolor(2);clrscr();
      gotoxy(5,3);cout << "Krem az j album kiadsnak vt :";
     do                                //Lekezeli a nem szmokat, a
	 {                             //DATUMMIN-nl kisebb szmokat,
	   betubeir(2,11,DATEMAX);     //s a DATUMMAX-nl nagyobb adatokat
	   cin >> setw(DATEMAX);
	   cin.getline(datum,sizeof(datum));
	   if (cin.gcount()>=sizeof(datum)-1)           clrbuff();
	   datumbe=atoi(datum);
	 }
	while (datumbe<DATUMMIN || datumbe>DATUMMAX);
      stilmat(13);
      window(3,20,55,20);textbackground(0);textcolor(2);clrscr();
      gotoxy(7,3); cout << "Krem az j album zenei stlusnak szmt:";
      do
       {
         betubeir(2,21,3);
         cin >> ws >> setw(3);
         cin.getline(stils,sizeof(stils));
         if (cin.gcount()>=sizeof(stils))           clrbuff();
         sti=atoi(stils);
       }
       while (sti<1 || sti>STILDB);
   strcpy(kiadat.eloado,nev);
   strcpy(kiadat.lemezcim,cim);
   kiadat.date=datumbe;
   kiadat.stilkod=sti;
   ellenoriz(kiadat);
   window(29,20,51,21); textcolor(9);clrscr();
   gotoxy(1,1); cout << "Megfelelnek az adatok?";
   gotoxy(9,2); cout << "(I/N)";
    textcolor(16);window(80,25,80,25);clrscr();
    ok=toupper(getch());
  }
 while(ok=='N');
	  //kirs fjlba
   regifile.open(fnev, ios::binary | ios::in);
        if (ujfile.fail())         hiba();
   ujfile.open(ftmp, ios::binary | ios::out);
        if (ujfile.fail())         hiba();
   regifile.read((char*)&beadat,sizeof(beadat));
   while( !regifile.eof() )
     {
         if (beadat.eloado[0]>=kiadat.eloado[0] && kilep==0)
            {
             if (beadat.eloado[0]==kiadat.eloado[0] && kilep==0)
                {
                meret1=sizeof(kiadat.eloado);
                meret2=sizeof(beadat.eloado);
                if (meret1<=meret2) meret=meret1;
                   else meret=meret2;
                 i=-1;
                 do
                   {
                   i++;
		   if (kiadat.eloado[i]<beadat.eloado[i])
                     {
                      ujfile.write((char*)&kiadat, sizeof(kiadat));
                      i=meret+1;
                      kilep=1;
                     }
                    else if (kiadat.eloado[i]>beadat.eloado[i])
                            i=meret;
                    }
                 while(i<meret);
                 if (i==meret && kiadat.eloado[i]==beadat.eloado[i])
                    {
                    ujfile.write((char*)&kiadat, sizeof(kiadat));
                    kilep=1;
                }   }
              else
                {
                ujfile.write((char*)&kiadat, sizeof(kiadat));
                kilep=1;
                }
	    }
          ujfile.write((char*)&beadat, sizeof(beadat));
      regifile.read((char*)&beadat,sizeof(beadat));
     }
   ujfile.seekg(0, ios::end);
   regifile.seekg(0, ios::end);
   if (ujfile.tellg()==regifile.tellg())
              ujfile.write((char*)&kiadat, sizeof(kiadat));
  ujfile.close();
  regifile.close();
  remove(fnev);
  rename(ftmp, fnev);
 _setcursortype(_NORMALCURSOR);
 }


void hiba()                   //Fjlkezelsi hiba!!!!
	{
	 window(1,1,80,25);textbackground(0);textcolor(15);clrscr();
	 cout << "Fjlmegnyitsi problma!!\n";
	 cout << "Nem sikerlt megnyitni a " << fnev<< " nev fjlt!\n";
         exit (1);
         }


void listakep()                              //Listzsi kp
   {
    textbackground(0),textcolor(15);window(1,1,80,25);clrscr();
    _setcursortype(_NOCURSOR);
    textbackground(1); textcolor(10); window(2,25,79,25);clrscr();
    gotoxy(9,1); cout << " - Lefel          - Felfel          Space - Visszatrs";
    textbackground(1);textcolor(15);
    window(20,2,60,2);clrscr();
    gotoxy(1,1); cout <<  "************   TELJES LISTA   ***********";
    textbackground(3);textcolor(1);
    window(2,4,79,4);clrscr();
    gotoxy(14,1);cout << "Elad";
    gotoxy(39,1);cout << "Album cme";
    gotoxy(57,1);cout << "Kiads ve";
    gotoxy(70,1);cout << "Stilus";
    textbackground(7); textcolor(0); window(1,5,80,24); clrscr();
   }


void lista()                       //Teljes lista
  {
  int sor=0,tovabb=0,tovabb2=0,kilep=0,filesor=0;
  long int mutato,mut;
  fstream listfile;
  rekord rekord1;
  listakep();
    listfile.open(fnev, ios::binary | ios::in);
           if (listfile.fail())     hiba();
    mut=listfile.tellg();
    listfile.read ((char*)&rekord1, sizeof(rekord1));
    while (kilep==0)
     {
      while(! listfile.eof() && kilep==0)
       {
       sor++;filesor++;
        if (sor==21)
           {
            while(tovabb!=32 && tovabb!=72 && tovabb!=80) tovabb=getch();
             switch (tovabb)
              {
               case 32:
                 kilep=1;
                 break;
               case 72:
                { filesor=filesor-41;
                  if (filesor<1) filesor=1;
                  mut=listfile.tellg();
                  mutato=mut-((41)*sizeof(rekord1));
		  if (mutato<0) mutato=0;
                  listfile.seekg(mutato, ios::beg);
                  listfile.read((char*)&rekord1, sizeof(rekord1));}
                  mut=listfile.tellg();
                  break;
                }
             sor=1;tovabb=0;clrscr();
           }
         if (kilep==1) continue;
         mut=listfile.tellg();
         sorkiir(filesor,sor,rekord1);
         listfile.read ((char*)&rekord1, sizeof(rekord1));
        }
       if (kilep==1) continue;
       while(tovabb2!=32 && tovabb2!=72)    tovabb2=getch();
       if (tovabb2==32)
          kilep=1;
         else{
          filesor=filesor-20-sor;
          if (filesor<0) filesor=0;
	  clrscr();
          mut=listfile.tellg();
          listfile.close();
          listfile.open(fnev,ios::binary | ios::in);
          mutato=(filesor*sizeof(rekord1));
           if (mutato<1) mutato=0;
          listfile.seekg(mutato, ios::beg);
          listfile.read ((char*)&rekord1, sizeof(rekord1));}
       tovabb2=0;sor=0;
      }
    listfile.close();
  _setcursortype(_NORMALCURSOR);
  }


void info()                           //Programinformci
  {
  alapkep();
  kiskeret();
  window(28,3,52,3);textcolor(9);clrscr();
  gotoxy(1,1);cout << "C D    K A T A L O G U S";
  window(27,7,53,9);textcolor(5);clrscr();
  gotoxy(1,1);cout << "Ksztette: Herhof Attila";
  gotoxy(7,3);cout << "2000. prilis";
  window(19,15,61,16);textcolor(9);clrscr();
  gotoxy(1,1);cout << "A program illetktelen msolst valamint";
  gotoxy(4,2);cout << "sokszorostst a trvny bnteti !";
  window(15,23,65,23);textcolor(1);clrscr();
  gotoxy(17,23);cout << "A visszatrshez krem nyomjon meg egy billentyt!";
  bill1();
  }


void kilepes(char& end)              //Kilps eldntse
  {
  alapkep();
  keret();window(27,10,57,10);textcolor(9);clrscr();
  gotoxy (1,1);cout << "Biztosan ki akar lpni (I/N) ?";
  textcolor(16);window(80,25,80,25);clrscr();
  end=toupper(getch());
  alapkep();
  }


//-------------- Fprogram ---------------------


void main ()
 {
 textmode (3);
 int menu;
 char kilep;

 alapkep();
 signal();
 do
  {
   fomenu(menu);
   switch (menu)
    {
    case 49:
      kereses();
      break;
    case 50:
      adatok();
      break;
    case 51:
      lista();
      break;
    case 52:
      info();
      break;
    case 53:
      kilepes(kilep);
      break;
    }
  }
 while (kilep!='I');
 window(1,1,80,25);textbackground(0);textcolor(15);clrscr();
 cout << " Ksznm, hogy ezt a programot hasznlta!\n";
 }
