/* Program TX007.c */
/*---------------------------------------------------------------------*/
/* Msodfok egyenlet megoldsa (ax+bx+c=0)                           */
/*---------------------------------------------------------------------*/
/* Az utols javts dtuma: 2000.02.20.                               */
/*---------------------------------------------------------------------*/

#include <stdio.h>
#include <math.h>

void main(void)
{
  float a, b, c ;  /* Az egyenlet egytthati */
  float x1, y1  ;  /* Az els gyk vals s kpzetes rsze */
  float x2, y2  ;  /* A msodik gyk vals s kpzetes rsze */
  float diszkr  ;  /* A diszkriminns */

  /* Adatbekrs */
  printf("Adja meg egy msodfok egyenlet egytthatit,\n");
  printf("ha ax+bx+c=0 !\n");
  printf("a : "); scanf("%f",&a);
  printf("b : "); scanf("%f",&b);
  printf("c : "); scanf("%f",&c);
  printf("\n");

  /* Az egyenlet megoldsa, az eredmnyek kiratsa */
  diszkr = b*b - 4*a*c;
  if (a == 0)
    if (b == 0)
      if (c == 0)
        printf("Vgtelen sok megolds van: minden x 'gyk'. \n");
      else
        printf("Nincs megolds: ellentmondsos az egyenlet. \n");
    else
     {
      x1 = -c/b;
      printf("Egy megolds van: x = %.11E \n", x1 );
     }
  else
    if (c == 0)
     {
      x1 = 0;
      x2 = -b/a;
      printf("Kt megolds van: x1 =  %.11E\n", x1 );
      printf("                  x2 =  %.11E\n", x2 );
     }
    else
      if (diszkr == 0)
       {
        x1 = -b/2/a;
        printf("Egy megolds van: x =%.11E\n", x1 );
       }
      else
       {
        x1 = -b/2/a;
        x2 = x1;
        y1 = sqrt(fabs(diszkr))/2/a;     /* Sqrt(a): az a ngyzetgyke */
        y2 = -y1;                /* fabs: a lebegpontos absz.rtk fv.*/
        if (diszkr < 0 )
         {
          printf("Kt komplex megolds van:\n");
          printf("    x1 = %.11E + j(%.11E)\n", x1, y1 );
          printf("    x2 = %.11E + j(%.11E)\n", x2, y2 );
         }
        else
         {
          printf("Kt vals megolds van: x1 =%.11E\n", x1 + y1 );
          printf("                        x2 =%.11E\n", x2 + y2 );
         }
       }
  printf("\n");
}

/*
A program futtatsa:
--------------------

Adja meg egy msodfok egyenlet egytthatit,
ha ax+bx+c=0 !
a : 11
b : 22
c : 33

Kt komplex megolds van:
    x1 = -1.0000000000E+00+ j( 1.41421353817E+00)
    x2 = -1.0000000000E+00+ j(-1.41421353817E+00)
*/
